﻿// VORLAGE FÜR TOOLS//

package  com.tools {
	
import com.events.SatCalcEvent;
import flash.display.Sprite;
import flash.display.*;
import flash.geom.*;
import flash.text.*;
import flash.events.*;
import FISEvents;
import com.utilities.*;
import flash.ui.Mouse;
import flash.utils.*;
import flash.net.*;


	public class FilterTool extends SatCalcDisplay {
	
	private var FilterChoice:FISDropDown;
	private var MainToolActive:Boolean = false;;
	public var StageZero:Point;
	private var Filter:Filters;
	private var Image_BMP:Bitmap;
	private var FilterImage:Bitmap;
	public var OutAt_X:int;					// an welche Stage Koordinaten werden die Overlays ausgegeben
	public var OutAt_Y:int;
	private var orgBild:BitmapData;
	public var Filter_mc:MovieClip; 
	public var HasDropFields:Boolean;
	public var HasGhosts:Boolean;
	public var DropFields:Array;
	public var IRZaehl_koord:Point;
	public var IRNenn_koord:Point;
	public var RZaehl_koord:Point;
	public var RNenn_koord:Point;
	public var ToolDims:Array;				// Die Abmessungen der Tools. Wird im SatCalculator benötigt um die Positionierung vorzunehmen
	public var Ident:String;				// Gleicht dem Namen des Objektes im Satcalculator
	private var Version:String;
	private var CalcTool:ClassifierBase;
	public var MetaOfCurrentData:Array;		// Metadaten Array des Momentan angezeigten Bildes(welches das Tool bearbeitet);;
	private var MessageTimer:Timer;		// Die Rückmeldung wenn berechnet wird braucht ein wenig Vorsprung, weil sie sonst nicht angezeigt wird
	private var DataWidth_:int;
	private var DataHeight_:int;
	
	
	private var FilterArray:Array;
	
	private var W:int;						// Höhe des auszuwertenden Bildes
	private var H:int;						// Breite des auszuwertenden Bildes

	
		public function FilterTool(outX:int,outY:int,varArr:Array,ID:String){
			
			Ident = ID;
			
			Version = "20130910"
			
			// Das Array in dem alle relevanten Daten zu den DropFields gespeichert sind
			
			DropFields = new Array();

			HasDropFields = false;
			HasGhosts	= false;
			trace ("FilterTool INVOKED: "+Version);
			
			FilterArray = varArr;
			trace("FILTER :" +FilterArray);
			
			OutAt_X=outX;
			OutAt_Y=outY;
			
			Filter_mc = new FiltersTool();
			addChild(Filter_mc);
			
			Filter = new Filters();
		
			FilterChoice = new FISDropDown([FilterArray[0].toString()]);
			this.addChild(FilterChoice);
			
			if (FilterArray.length >1){
				
				for (var i = 1;i<=FilterArray.length-1;i++){
					trace (FilterChoice.Choices);
					FilterChoice.Choices.push(FilterArray[i].toString());
				}
				FilterChoice.reInit();
			}
			
			
			FilterChoice.y = 4;
			FilterChoice.x = 55;
			FilterChoice.DropBox.drpText.text = "Filter wählen!";
			//FilterChoice.addEventListener(FISEvents.DATA_READY,switchFormula);
			
			ToolDims = new Array();
			ToolDims[0] =[Filter_mc.width,Filter_mc.height];
			MetaOfCurrentData = new Array()
			this.addEventListener(Event.ADDED_TO_STAGE, initListeners);
			
			
			
			CalcTool = new ClassifierBase();
		}// Constructor close
		
		
		private function initListeners(e:Event){
			
			this.addEventListener(SatCalcEvent.DISPLAY_UPDATE,initImage)
	
		}
		
		private function messageAndStart(e:MouseEvent){
			dispatchEvent(new SatCalcEvent(SatCalcEvent.AIR_MESSAGE,[true,FilterChoice.CurrentChoice+" Filter"+"\n"+"wird angewendet"]));
			MessageTimer = new Timer(100,1);
			MessageTimer.addEventListener(TimerEvent.TIMER_COMPLETE,filterImage);
			MessageTimer.start();
		}
		

		
		private function initImage(e:SatCalcEvent){
			MetaOfCurrentData =  e.data[1];
			
			trace ("METADATA IN FILTER :"+MetaOfCurrentData);
			W=MetaOfCurrentData[7][0];
			H=MetaOfCurrentData[7][1];
			//trace ("WH :"+W+" "+H)
			if (e.data[0] instanceof Bitmap){
				
				Image_BMP = new Bitmap(Bitmap(e.data[0]).bitmapData.clone());
			}
			if (e.data[0] instanceof Array){
				
				  	Image_BMP=CalcTool.returnBitmapFromArray(e.data[0],W,H);
					
			}
			

			Filter_mc.StartFilter_mc.addEventListener(MouseEvent.MOUSE_DOWN,messageAndStart);
			Filter_mc.StartFilter_mc.gotoAndStop(1);
			
		}

		
		private function filterImage(e:TimerEvent){
			
			
			
			MessageTimer.removeEventListener(TimerEvent.TIMER_COMPLETE,filterImage);
			var outArray:Array = new Array();
			var ourDataArray:Array = new Array();
			outArray =  mergeMetaArray();
			FilterImage = new Bitmap(new BitmapData(Image_BMP.width,Image_BMP.height));
			switch(FilterChoice.CurrentChoice){
				case "Mittelwert" :
				trace ("Mittelwert Filter");
				FilterImage = Filter.meanFilter(Image_BMP,false);
				break;
				case "Median":
				trace ("Median Filter");
				FilterImage = Filter.medianFilter(Image_BMP);
				break;
				case "EdgeDetect":
				trace ("EdgeDetect Filter");
				FilterImage = Filter.sobelCombVertHortEdges(Image_BMP);
				break;
				case "CannyEdges":
				trace ("EdgeDetect Filter");
				FilterImage = Filter.cannyEdges(Image_BMP);
				break;
			}
				
				
			
			// Das Array welches an den SatCalc weitergegeben wird mit DatenArray und Metadaten und 
			
			//ourDataArray = CalcTool.returnBitmapToArray(FilterImage);
			
			this.dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_DISPLAY,[FilterImage,outArray[0],outArray[1],outArray[2],outArray[3],outArray[4],outArray[5],outArray[6]]));
														//					Daten			width		height		Name		NDVI	Auflösung	 Einheit		Datum				
			dispatchEvent(new SatCalcEvent(SatCalcEvent.AIR_MESSAGE,[false,""]));
			
			
		}
	
		
		// Kombiniert die Metadatenarrays der eingangsdaten zu einem MetadatenArray ders Ergebnisbildes
		private function mergeMetaArray():Array{
			
			var returnArray:Array = new Array();
			returnArray[0] = Image_BMP.width;
			returnArray[1] = Image_BMP.height;
			returnArray[2] = MetaOfCurrentData[0];
			
			returnArray[3] = FilterChoice.CurrentChoice;
			returnArray[4] = MetaOfCurrentData[3];
			returnArray[5] = MetaOfCurrentData[4];
			returnArray[6] = MetaOfCurrentData[2];
			return returnArray;
	
		}
	
	
			
	} // Class Close

}//Package close
	

	
