﻿package com.tools {
	import com.events.SatCalcEvent;
	import flash.display.Sprite;
	import flash.display.*;
	import flash.geom.*;
	import flash.text.*;
	import flash.events.*;
	import FISEvents;
	import flash.ui.Mouse;
	import flash.utils.*;
	import flash.net.*;
	
	
	public class PointLine extends Sprite{
		
		public var Xextend:uint;
		public var Yextend:uint;
		
		var TwoPointArray:Array;	// Beinhaltet die beiden Punkte eine 2 Punkte Messung
		public var PointArray:Array;	// Beinhaltet die beiden Punkte eine Mehrpunkte Messung 
		var DrawPlane:Shape;	// Da drauf wird gezeichnet
		var DrawPlane_mc:MovieClip;	// Container für DrawPlane
		var DrawLine:Shape;
		//var DrawPoint:Shape;	// Shape für den Linienpunkt
		//var LinePoint:MovieClip;	// Ein Punkt einer linie
		public var PointColor_outer:uint;	// Aussenfarbe des Punktes
		public var PointColor_inner:uint;	// Innenfarbe des Punktes
		public var LineThickness:int		// wie dick wird die Linie
		public var LinePointRadius:int;		// Radus eines Linienpunktes
		public var TextColor:uint;		// Farbe des Textes
		public var RoundValues:Number;		// Runden auf Nachkommastellen
		var DrawPlane_B:Bitmap;	// Bitmap als Hintergrund für die Zeichenfläche
		var DrawPlane_BD:BitmapData;
		private var CurrentlyMovedPoint:String // Welcher Punkt wird momentan bewegt
		
		public var LineLabel:String;
		
		public var Resolution:Number;	// Auflösung des Bildes 
		public var Unit:String;			// Distanzeinheit des Bildes.
		
		public var SelectionMode:Boolean; // kann überhaupt was gemachte werden true = ja false = nein;
		public var Mode:String;			// sol eine zwei oder mehrpunktlinie angelegt werden "twoPoint" "multiPoint"
		
		
		public function PointLine(w:int,h:int,m:String="twoPoint"){
			
			trace ("PointLine gestartet")
			
			Xextend = w;
			Yextend = h;
			
			Mode = m;
			
			PointColor_outer = 0x00ff00;
			PointColor_inner = 0xff0000;
			LinePointRadius = 5;
			TextColor = 0x000000;
			LineThickness = 3;
			RoundValues=1;
			
			SelectionMode = true;
			
			//DrawPlane_BD = new BitmapData(Xextend,Yextend,true,0x00000000)
			//DrawPlane_B = new Bitmap(DrawPlane_BD);
			//addChild(DrawPlane_B);
			
			DrawPlane = new Shape();
			
			DrawPlane_mc = new MovieClip();
			
			//this.mouseChildren = false;

			PointArray = new Array();
		
		}// Constuctor close
		
		// legt einen neuen Linienpunkt mit dazugehörigem Textfeld an
		
		private function returnNewLinePoint():MovieClip{
			var DrawPoint = new Shape();
			DrawPoint.graphics.beginFill(PointColor_outer);
			DrawPoint.graphics.drawCircle(0,0,LinePointRadius);
			DrawPoint.graphics.endFill();
			DrawPoint.graphics.beginFill(PointColor_inner);
			DrawPoint.graphics.drawCircle(0,0,LinePointRadius/1.5);
			DrawPoint.graphics.endFill();
			
			var font:Font = new Arial_type as Font; //FontClass was exported from Flash IDE
			var textFormat:TextFormat = new TextFormat(font.fontName);
			var TField = new TextField();
			TField.defaultTextFormat = textFormat;
			//TField.width = 30;
			//TField.height = 20;
			TField.x = 2;
			TField.y = 2;
			
			TField
			TField.name="Value";
			TField.textColor = TextColor;
			TField.selectable=false;
			TField.autoSize= TextFieldAutoSize.LEFT;
			TField.embedFonts = true;
			var LinePoint = new MovieClip();
			
			addChild(LinePoint);
			LinePoint.addChild(DrawPoint);
			LinePoint.addChild(TField);
			
			return LinePoint ;
			
		}
		

		// setzt einen neuen Linienpunkt an die Stelle des Mausklicks
		
		public function addNewPoint(){
			
			if (SelectionMode == true){
				var PointClip:MovieClip = returnNewLinePoint();
				PointClip.name = (PointArray.length).toString();
				PointClip.x = mouseX;
				PointClip.y = mouseY;
				var templength:uint
				var lastArrayPos:int // letzte Stelle im PointArray
				
				PointArray.push([PointClip.name,PointClip.x,PointClip.y,0]);
				lastArrayPos = PointArray.length-1;
				// die Länge der Segmente zwischen den Punkten wird ermittelt
				// funktioniert natürlich nur wenn das Array mehr als einen Punkt gespeichert hat
				if (PointArray.length>1){
					templength = returnSegmentLength([PointArray[lastArrayPos-1][1],PointArray[lastArrayPos-1][2],PointArray[lastArrayPos][1],PointArray[lastArrayPos][2]]);
					PointArray[lastArrayPos][3] = templength + PointArray[lastArrayPos-1][3];
					PointClip.getChildByName("Value").autoSize= TextFieldAutoSize.LEFT;
					PointClip.getChildByName("Value").text = LineLabel;
					PointClip.getChildByName("Value").mouseEnabled = false;
					// wenn nur eine Zweipunktlinie angelegt werden soll wird bei PointArray länge >2 abgebrochen
					if (Mode == "twoPoint" && PointArray.length>=2){
						SelectionMode = false;
						terminateDraw();
					}
				}
				
				if (PointArray.length<1){
					templength = returnSegmentLength([PointArray[lastArrayPos-1][1],PointArray[lastArrayPos-1][2],PointArray[lastArrayPos][1],PointArray[lastArrayPos][2]]);
					PointArray[lastArrayPos][3] = 0;
				}
				
				trace ("new Point at :" + PointArray);
				addChild(PointClip);
				if (PointArray.length>1){
					drawSegments();
				}
				
			}
			
		}
		
		
		// Ein gesetzter Punkt wird aufgenommen
		private function initMovePoint(e:MouseEvent){
			
				CurrentlyMovedPoint = MovieClip(e.currentTarget).name;
				e.currentTarget.startDrag();
				this.addEventListener(MouseEvent.MOUSE_MOVE,movePoint,false,0,true);
			
			
		}
		
		// Ein aufgenommener Punkt wird fallengelassen und seine neue Position ins Point Array geschrieben
		private function dropPoint(e:MouseEvent){
			
			e.currentTarget.stopDrag();
			this.removeEventListener(MouseEvent.MOUSE_MOVE,updateSegments);
			PointArray[Number(e.currentTarget.name)][1] = mouseX;
			PointArray[Number(e.currentTarget.name)][2] = mouseY;
			trace (PointArray);
			// Überprüfung ob der Punkt ausserhalb des Arbeitsbereiches liegt 
			if (getChildByName(CurrentlyMovedPoint).x >= Xextend){
				getChildByName(CurrentlyMovedPoint).x = Xextend-1;
				updateSegments();
			}
			else if (getChildByName(CurrentlyMovedPoint).x <= 0){
				getChildByName(CurrentlyMovedPoint).x = 1;
				updateSegments();
			}
			else if (getChildByName(CurrentlyMovedPoint).y <= 0){
				getChildByName(CurrentlyMovedPoint).y = 1;
				updateSegments();
			}
			else if (getChildByName(CurrentlyMovedPoint).y >=Yextend){
				getChildByName(CurrentlyMovedPoint).y = Yextend-1;
				updateSegments();
			}
		}
		
		// Die Linie wird beendet und die Punkte mit Event listenern fürs Verschieben ausgestattet
		
		public function terminateDraw(){
			trace("BEENDEN!!!!");
			
			/*this.removeEventListener(MouseEvent.MOUSE_DOWN, addNewPoint);
			this.removeEventListener(MouseEvent.DOUBLE_CLICK, terminateDraw);
			this.mouseChildren = true;*/
			
			// Beim Doppelklick wird ein überflüssiger Punkt angelegt, Dieser wird gelöscht
			//var lastArrayPos:int = PointArray.length-1; // letzte Stelle im PointArray
			//removeChild(getChildByName(PointArray[lastArrayPos][0]));
			
			//PointArray.length = PointArray.length-1;
			//PointArray.length = PointArray.length-1;
			
			for (var i =0; i<PointArray.length;i++){
				trace ("adding listeners to: "+ PointArray[i][0]);
				MovieClip(getChildByName(PointArray[i][0])).addEventListener(MouseEvent.MOUSE_DOWN,initMovePoint);
				MovieClip(getChildByName(PointArray[i][0])).addEventListener(MouseEvent.MOUSE_UP,dropPoint);
				MovieClip(getChildByName(PointArray[i][0])).buttonMode = true;
				
				
			}
		}
		
		private function movePoint(e:MouseEvent){
			PointArray[Number(CurrentlyMovedPoint)][1] = mouseX;
			PointArray[Number(CurrentlyMovedPoint)][2] = mouseY;
			updateSegments();
		}
		
		// Funktion Berechnt die Segmente während der Bewegung eines Punktes neu
		public function updateSegments(){
			trace( "UpdatingSegments");
			
			if (CurrentlyMovedPoint){
			PointArray[Number(CurrentlyMovedPoint)][1] = getChildByName(CurrentlyMovedPoint).x;
			PointArray[Number(CurrentlyMovedPoint)][2] =  getChildByName(CurrentlyMovedPoint).y;
			}
			
			// Beschränkung auf die Grösse des Bildes
			if (getChildByName(CurrentlyMovedPoint).x >= Xextend || getChildByName(CurrentlyMovedPoint).y >= Yextend || getChildByName(CurrentlyMovedPoint).y <= 0 || getChildByName(CurrentlyMovedPoint).x <= 0){
			 getChildByName(CurrentlyMovedPoint).dispatchEvent(new MouseEvent(MouseEvent.MOUSE_UP));
			}
			
			// Für den ersten Punkt bleibt die Strecke 0
			
				for (var i=1;i<PointArray.length;i++){
					var templength:Number;
					trace ("changing Point Array at: " +i);
					templength = returnSegmentLength([PointArray[i-1][1],PointArray[i-1][2],PointArray[i][1],PointArray[i][2]]);
					PointArray[i][3] = templength + PointArray[i-1][3];
					//PointArray[i][3] = Math.round(PointArray[i][3]/RoundValues)*RoundValues
				    getChildByName(PointArray[i][0]).getChildByName("Value").text =LineLabel;;
				}
				
			
			drawSegments();
			
			
		}
		
		//zeichnet die Segmente
		private function drawSegments(){
			try {
			DrawPlane.graphics.clear();
			DrawPlane_mc = new MovieClip();
			}
			catch(e:Error){};
			
			for (var i =0;i<PointArray.length;i++){
				if (i<(PointArray.length-1)){
					
					DrawPlane.graphics.lineStyle(LineThickness,PointColor_outer);
					DrawPlane.graphics.moveTo(PointArray[i][1],PointArray[i][2]);
					DrawPlane.graphics.lineTo(PointArray[i+1][1],PointArray[i+1][2]);
				}
				addChild(DrawPlane_mc);
				DrawPlane_mc.addChild(DrawPlane);
			}
			
			DrawPlane_mc.mouseEnabled = false;
				rotateLabels();
		}
		
		private function returnSegmentLength(Points:Array):Number{
			var lengthA:Number = returnDifference([Points[0],Points[2]]);
			var lengthB:Number = returnDifference([Points[1],Points[3]]);
			var	lengthC:Number;
			
			lengthC = Math.sqrt(Math.pow(lengthA,2) + Math.pow(lengthB,2))
			return lengthC;
		}
		
		
		// gibt die Differnz zweier Zahlen zurück
		private function returnDifference(inArray:Array):Number{
			var diff:Number = inArray[0] -  inArray[1];
			if (diff<0){
				diff = diff *-1;
			}
			
			trace ("Differenz aus : " +inArray[0]+" " + inArray[1] +"=" +diff);
			
			return diff;
			
		}
		// alles Säubern
		public function purge(){
		removeChild(DrawPlane_mc);
		DrawPlane = new Shape();
		DrawPlane_mc = new MovieClip();
			for(var i = 0; i < PointArray.length;i++){
				removeChild(getChildByName(PointArray[i][0]));
			}
				
		PointArray = new Array();
		
		}
		
		private function rotateLabels(){
			
			for (var i =0;i<PointArray.length;i++){
				if (i<(PointArray.length-1)){
					var PointA = new Point(MovieClip(getChildByName(PointArray[i][0])).x,MovieClip(getChildByName(PointArray[i][0])).y);
					var PointB = new Point(MovieClip(getChildByName(PointArray[i+1][0])).x,MovieClip(getChildByName(PointArray[i+1][0])).y);
					var ghostpoint:Point = new Point(PointB.x,PointA.y);
					var gkath:Number = returnDifference([PointB.y,ghostpoint.y]);
					var akath:Number = returnDifference([PointA.x,PointB.x]);
					var tan = gkath/akath;
					var angle = Math.atan(tan);
					angle = angle *180/Math.PI;
					if (PointB.y < ghostpoint.y){
						angle = angle*-1;
					}
					MovieClip(getChildByName(PointArray[i][0])).rotation = angle;
					trace ("Gegenkathete: "+gkath + " Ankathete: "+ akath+ " Ghost: " +ghostpoint + " " +angle + " "+tan);
				}
				
			}
			
		}
		
		
		
	} //Class close
}//Package close