﻿package com.window
{
	
	import com.events.*;
	import com.interfaces.IDragDropable;
	import com.transitions.FadeObject;
	
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.*;
	import flash.events.MouseEvent;
	import flash.geom.*;
	import flash.geom.Point;
	import flash.text.Font;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.*;
	
	
	
	public class FISWindow extends WindowBase{
		
		private var ScrollBar_V:FISScrollbar; 
		private var ScrollBar_H:FISScrollbar; 
		private var BackgroundWidth:uint;
		private var BackgroundHeight:uint;
		private var ScrollBarH_spacing:uint = 6;
		private var ScrollBarV_spacing:uint = 6;
		public var FISWindowVersion:String = "20130808";
		
		// [0] = Text [1] = Xpos [2] = Ypos [3] = Xsize [4] = Ysize [5] = Farbe
		public function FISWindow(tX:String="",xP:int=0,yP:int=0,xS:int=100,yS:int=100,da:Boolean=false)
		{
			super(tX,xP,yP,xS,yS);
			
			trace ("FISWindowV: "+FISWindowVersion);
			
		  	 TextColor = 0xffffff; // Textfarbe
			 BackColor =  0xFFFFFF;// HintergrundFarbe
			 FrameColor = 0x2F7BC8;// RahmenFarbe
			 RelocColor = 0x6F9BC9;// Farbe des RelocationButtons
			 BackAlpha = 1; // AlphaWert des Hintergrundes
			 RelocAlpha = 1;// AlphaWert des Reloc buttons
			 FrameStrengh = 1;// RahmenDicke
			 Dragable = da;
			 
			 ContentOffsetX=4;
			 ContentOffsetY=25
			 
			 trace ("dragable: "+Dragable);
			// Die Fläche auf der das Anzeigeobjekt sichtbar ist
			 
			 WindowArea = new Rectangle(3,27,xS,yS-30);
			 
			 // wenn neuer Content geadded wurde kann hier was ausgelöst werden
			 addEventListener(WindowEvents.CONTENT_ADDED, onContentAdded);
			
		}
		
		
		
		public function initWindow():void{
			
			renewWindow();
			
			trace ("CHILDREN IN GORUP "+ Group.numChildren);
			
			var Frame:Shape = new Shape();
			
			// Der Rahmen
			Frame.graphics.beginFill(FrameColor,RelocAlpha);
			Frame.graphics.lineStyle(FrameStrengh,FrameColor);
			Frame.graphics.drawRoundRect(0,0,Xsize,Ysize,20,20);
			
			// Der Hintergrund vor dem der Content platziert wird
			var Background:MovieClip = new MovieClip();
			Background.graphics.beginFill(BackColor,BackAlpha);
			Background.graphics.lineStyle(0,FrameColor);
			Background.graphics.drawRoundRect(3,25,Frame.width-ScrollBarV_spacing-3,Frame.height-25-ScrollBarH_spacing,20,20)
			BackgroundWidth= Xsize*0.93;
			BackgroundHeight= Ysize*0.91;
			
			WindowArea = new Rectangle(3,25,Background.width,Background.height);
			
		
		Group.addChild(Frame);
		Group.addChild(Background);
		createMask();
		//MovieClip(Group.getChildAt(1)).mouseEnabled = false;
		//MovieClip(Group.getChildAt(1)).mouseChildren = false;
		
		// Der Close Button
		
		// NormalStatus
		var closeNorm:Shape = new Shape();
		
		closeNorm.graphics.beginFill(RelocColor,1);
		closeNorm.graphics.lineStyle(0,RelocColor);
		closeNorm.graphics.drawRoundRect(0,0,15,15,8,8);
		closeNorm.graphics.lineStyle(3,0xffffff);
		closeNorm.graphics.moveTo(5,5);
		closeNorm.graphics.lineTo(10,10);
		closeNorm.graphics.moveTo(10,5);
		closeNorm.graphics.lineTo(5,10);
		
		// OverStatus
		var closeOver:Shape = new Shape();
		
		closeOver.graphics.beginFill(RelocColor,1);
		closeOver.graphics.lineStyle(0,RelocColor);
		closeOver.graphics.drawRoundRect(0,0,15,15,8,8);
		closeOver.graphics.lineStyle(2,0xFF0000);
		closeOver.graphics.moveTo(5,5);
		closeOver.graphics.lineTo(10,10);
		closeOver.graphics.moveTo(10,5);
		closeOver.graphics.lineTo(5,10);
		
		CloseButton = new SimpleButton(closeNorm,closeOver,closeNorm,closeNorm);
		CloseButton.x = Xsize-CloseButton.width-3;
		CloseButton.y = 4;
		CloseButton.addEventListener(MouseEvent.MOUSE_DOWN, onCloseWindow);
		
		Group.addChild(CloseButton);
		CloseButton.enabled = true;
		
			if (Dragable==true){
				trace("WINDOW DRAGABLE")
				Relocate_mc = new MovieClip();
				
				var Relocate:Shape = new Shape();
				Relocate.graphics.beginFill(RelocColor,RelocAlpha);
				
				Relocate.graphics.lineStyle(0,RelocColor);
				Relocate.graphics.drawRoundRect(4,4,Background.width-CloseButton.width,15,8,8);
				
				Relocate_mc.addChild(Relocate);
				Group.addChild(Relocate_mc);
				Relocate_mc.addEventListener(MouseEvent.MOUSE_DOWN, dragIt);
				stage.addEventListener(MouseEvent.MOUSE_UP, dropIt);
				Relocate_mc.buttonMode=true;

			}
			
			Group.x=Xpos;
			Group.y=Ypos;
			initTitle();
			
		}
		
		public function initTitle(){
			trace("adding Title");
			Title.width= Xsize;
			Title.height = Xsize/10;
			
			var myFont:Font = new Arial_type();
			var format:TextFormat = new TextFormat();
			format.font = myFont.fontName  ;
			format.color = TextColor;
			format.size = 13
			
			format.align = "center";
			//format.bold = true;
			Title.text = TitleText;
			Title.setTextFormat(format);
			Title.embedFonts=true;
			Title.selectable=false;
			
			
			Title.x = 0 
			Title.y = 2 
			
			Title.mouseEnabled  = false;
			
			Group.addChild(Title); 
			
		}
		
		public function resizeWindow(newWidth:int, newHeight:int){
			Xsize = newWidth;
			Ysize = newHeight;
			
			initWindow();
		}
		
		// Fürs FIS Window solls ne Maske mit runden Ecken sein
		override protected function createMask(){
			var Mask_mc = new MovieClip();
			var MaskShape = new Shape();
			MaskShape.graphics.beginFill(0xFF000000,1);
			MaskShape.graphics.drawRoundRect(WindowArea.topLeft.x,WindowArea.topLeft.y,WindowArea.width,WindowArea.height,20,20);
			
			Mask_mc.addChild(MaskShape);
			Group.addChild(ContentContainer)
			Group.addChild(Mask_mc);
			Group.getChildByName("WINDOW").mask = Mask_mc;
		
			
			//MaskShape.blendMode = BlendMode.DIFFERENCE;
			//Group.getChildByName("WINDOW").blendMode = BlendMode.LAYER;
			 
		}
		
	
		private function initScrollBar_V():void{
			try{ScrollBar_V.removeEventListener(WindowEvents.WINDOW_SCROLL,moveContentV);
				trace (" ScrollBar_V removed");}
			catch(e:Error){}
			trace ("INIT ScrollBar_V");
			ScrollBar_V = new FISScrollbar(WindowArea.height-ScrollBarH_spacing,10,(WindowArea.height/ContentContainer.height));
			ScrollBar_V.x = WindowArea.width+ScrollBarV_spacing/3;
			ScrollBar_V.y = 30;
			
			Group.addChild(ScrollBar_V);
			trace (ScrollBar_V.ScrollPercentage);
			ScrollBar_V.addEventListener(WindowEvents.WINDOW_SCROLL,moveContentV);
			
		}
		
		private function initScrollBar_H():void{
			trace ("INIT ScrollBar_H");
			try{ScrollBar_H.removeEventListener(WindowEvents.WINDOW_SCROLL,moveContentH);
				trace (" ScrollBar_V removed");}
			catch(e:Error){}
			ScrollBar_H = new FISScrollbar(WindowArea.width-ScrollBarV_spacing,10,(WindowArea.width/ContentContainer.width));
			ScrollBar_H.x = 3;
			ScrollBar_H.y = WindowArea.height+ScrollBarV_spacing+18;
			ScrollBar_H.rotation = -90;
			
			Group.addChild(ScrollBar_H);
			trace (ScrollBar_H.ScrollPercentage);
			ScrollBar_H.addEventListener(WindowEvents.WINDOW_SCROLL,moveContentH);
			
		}
		
		private function moveContentV(e:WindowEvents):void{
			ContentContainer.y = -(Number(e.data)*((ContentContainer.height-BackgroundHeight)/100)-ContentOffsetY);
			trace ("CONTY : "+ ContentContainer.y);
		}
		
		private function moveContentH(e:WindowEvents):void{
			ContentContainer.x = -(Number(e.data)*((ContentContainer.width-BackgroundWidth)/100)+ContentOffsetX);
		}
		
		// Wenn der hinzugefügte Inhalt höher ist als die Anzeigefläche, muss gescrollt werden
		private function onContentAdded(e:WindowEvents){
			
			if(ContentContainer.width<WindowArea.width && ContentContainer.height>WindowArea.height ){
			trace ("V Scrollbar");
			ScrollBarV_spacing= 25;
			initWindow();
			initScrollBar_V();
			Group.addChild(ScrollBar_V);
			FadeObject.fadeIn(ScrollBar_V,0.02);
			}
			
			else if(ContentContainer.width>WindowArea.width && ContentContainer.height>WindowArea.height ){
				trace ("HV Scrollbar");
				ScrollBarV_spacing= 25;
				ScrollBarH_spacing= 25;
				initWindow();
				initScrollBar_V();
				initScrollBar_H();
				Group.addChild(ScrollBar_V);
				Group.addChild(ScrollBar_H);
				FadeObject.fadeIn(ScrollBar_V,0.02);
				FadeObject.fadeIn(ScrollBar_H,0.02);
			}
			
			else{initWindow()}
			
		}
		
		private function onCloseWindow(e:MouseEvent){
			this.dispatchEvent(new WindowEvents(WindowEvents.WINDOW_CLOSE));
		}
		
		private function renewWindow(){
	
			var i = Group.numChildren; 
			while (--i >= 0) {
			Group.removeChildAt(i);
			}
		}
		
	
	
	}
}