﻿package com.window
{
	import com.events.*;
	import com.interfaces.IDragDropable;
	import com.transitions.FadeObject;
	import com.utility.WindowLoadingBar;
	import com.utility.WindowInfoLoad;
	
	import flash.display.BlendMode;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.ProgressEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;

	
	
	public class WindowBase extends Sprite implements IDragDropable
	{
				
		public var Relocate_mc:MovieClip;
		public var CloseButton:SimpleButton;
		public var Close_mc:MovieClip; // Schliessen Button muss im Main.fla vorliegen
		public var Group:Sprite// Container für Alles
		public var Xsize:int // Textgrösse
		public var Ysize:int // Textgrösse
		public var Xpos:int // XPosition
		public var Ypos:int // YPosition
		
		public var ContentOffsetX:Number = 1;// wo wir der Inhalt angezeigt
		public var ContentOffsetY:Number = 1;// 
		
		public var TextColor:uint = 0x000000; // Textfarbe
		public var BackColor:uint =  0x000000;// HintergrundFarbe
		public var FrameColor:uint = 0xffffff;// RahmenFarbe
		public var RelocColor:uint = 0xff0000;// Farbe des RelocationButtons
		public var BackAlpha:Number = 1; // AlphaWert des Hintergrundes
		public var RelocAlpha:Number = 1;// AlphaWert des Reloc buttons
		public var FrameStrengh:int = 1;// RahmenDicke
		public var ContentContainer:MovieClip;
		
		public var TitleText:String // Der Text
		public var TextArray:Array;
		public var Title:TextField//Textfeld
		public var StopMode:Boolean// Ist der StopMode true hält die Textausgabe an
		public var RestrictionPoint_1:Point // Obere linke Ecke des Begrenzungsfeldes in welchem das Fenster bewegt werden soll
		public var RestrictionPoint_2:Point // Untere linke Ecke des Begrenzungsfeldes in welchem das Fenster bewegt werden soll
		
		//public var Mask_mc:MovieClip;	//
		public var Version:String = "20130918";
		public var Dragable:Boolean;
		
		public var WindowArea:Rectangle;
		
		// Inhalte
		
		public var SWFContent:WindowInfoLoad;
		
		public var LoadingProgress:WindowLoadingBar;
		
		public function WindowBase(tX:String="",xP:int=0,yP:int=0,xS:int=100,yS:int=100,da:Boolean=false)
		
		{
			super();
			
			trace ("WindowBaseV: "+Version);
			
			Title = new TextField();
			
			TextArray = new Array();
			Group=new Sprite();
			addChild(Group);
			StopMode=false;
			Dragable = da;
			TitleText = tX;
			Xpos = xP;
			Ypos = yP;
			Xsize = xS;
			Ysize = yS;
			this.addEventListener(Event.ADDED_TO_STAGE,setRestriction);
	
		}
		
		public function setRestriction(e:Event):void
		{
			
			RestrictionPoint_1 =  globalToLocal(new Point(0,0));
			RestrictionPoint_2 =  globalToLocal(new Point(stage.stageWidth,stage.stageHeight));
			
			//trace ("RESTRICION " + RestrictionPoint_1 +" "+ RestrictionPoint_2);
			trace ("RESTRICION " + RestrictionPoint_1,RestrictionPoint_2);
		}
		
		public function renewRestriction():void
		{
			
			RestrictionPoint_1 =  globalToLocal(new Point(0,0));
			RestrictionPoint_2 =  globalToLocal(new Point(stage.stageWidth,stage.stageHeight));
			
			//trace ("RESTRICION " + RestrictionPoint_1 +" "+ RestrictionPoint_2);
			trace ("RESTRICION " + RestrictionPoint_1,RestrictionPoint_2);
		}
		
		public function resetRestriction(x1:int, y1:int, x2:int, y2:int):void
		{
			RestrictionPoint_1 =  globalToLocal(new Point(x1,y1));
			RestrictionPoint_2 =  globalToLocal(new Point(x2,y2));
			
			//trace ("RESTRICION " + RestrictionPoint_1 +" "+ RestrictionPoint_2);
			trace ("RESTRICION " + RestrictionPoint_1,RestrictionPoint_2);
		}
		
		public function dragIt(e:Event):void
		{
			Group.startDrag(); 
			Group.addEventListener(MouseEvent.MOUSE_MOVE,checkRestriction);
			Group.addEventListener(MouseEvent.MOUSE_OUT,dropIt);
		}
		
		public function dropIt(e:Event):void
		{
			Group.stopDrag(); 
			Group.removeEventListener(MouseEvent.MOUSE_MOVE,checkRestriction);
			Group.removeEventListener(MouseEvent.MOUSE_OUT,dropIt);
		}
		
		public function checkRestriction(e:Event):void
		{
			trace ("Checking Restriction");
			if(Group.x >=(RestrictionPoint_2.x-Xsize)){
				Group.x = RestrictionPoint_2.x-Xsize;
				
			}
			else if (Group.x <=RestrictionPoint_1.x){
				Group.x = RestrictionPoint_1.x;
				
			}
			
			
			if(Group.y >=(RestrictionPoint_2.y-Ysize)){
				Group.y = RestrictionPoint_2.y-Ysize;
				
			}
			else if (Group.y <=RestrictionPoint_1.y){
				Group.y = RestrictionPoint_1.y;
				
				
			}
		}
		
		public function addSWFContent(CName:String){
			
			
		try{
			trace ("OLD CONTENT REMOVED")
			Group.removeChild(ContentContainer);
		}
		catch(e:Error){
			
		}
		trace ("adding SWF Content");
		SWFContent = new WindowInfoLoad(CName,0,0);
		SWFContent.name = "SWF";
		SWFContent.addEventListener(FISEvents.SWF_INIT,addContenttoWindow);
		SWFContent.addEventListener(FISEvents.CALC_PROGRESS, checkProgress); 
		
		
		}
		
		private function addContenttoWindow(e:FISEvents){
			trace("addingContent");
			SWFContent.addEventListener(FISEvents.DATA_READY,signalOut);
			addContainer("WINDOW",SWFContent,0,0);
			LoadingProgress.resetLoadingBar();
			this.removeChild(LoadingProgress);
			LoadingProgress = null;
		}
		
		
		
		public function addContainer(CName:String,cont:DisplayObject,xpos:Number=0,ypos:Number=0){
			
			trace ("NAME" +cont.name);
			ContentContainer = new MovieClip();
			ContentContainer.x = xpos + ContentOffsetX;
			ContentContainer.y = ypos + ContentOffsetY;
			trace ("CONTAINER X:"+ ContentOffsetY);
			ContentContainer.name = CName;
			
			if (cont.name == "SWF"){
				ContentContainer.addChild(SWFContent);
			}
			else{
				ContentContainer.addChild(cont);
			}
			
		
			
			trace ("Size of Container: " +ContentContainer.height+" " +ContentContainer.width);
		
			this.dispatchEvent(new WindowEvents(WindowEvents.CONTENT_ADDED));
		}
		// eine Maske für das Fenster
	protected function createMask(){
			var Mask_mc = new MovieClip();
			var MaskShape = new Shape();
			MaskShape.graphics.beginFill(0xFF000000,1);
			MaskShape.graphics.drawRect(WindowArea.topLeft.x,WindowArea.topLeft.y,WindowArea.width,WindowArea.height);
			
			Mask_mc.addChild(MaskShape);
			Group.addChild(ContentContainer)
			Group.addChild(Mask_mc);
			Group.getChildByName("WINDOW").mask = Mask_mc;
			
				
		}
	
	private function signalOut(e:FISEvents){
		trace ("SIIGNAL");
	}
	
	private function checkProgress(e:FISEvents) { 
		trace("LOADING: "+e.data[0]+ " " +e.data[1]);
		if (LoadingProgress){
		LoadingProgress.updateLoadingBar(e.data[0])
		trace("LOADING: "+e.data[0]+ " " +e.data[1]);
		this.addChild(LoadingProgress);
		}
		else{
			trace ("creating Loading Bar")
			LoadingProgress = new WindowLoadingBar(e.data[1],0,0,Xsize/2,10,0x2F7BC8,0x6F9BC9);
			LoadingProgress.x = Group.x + ((Xsize/2)/2);
			LoadingProgress.y = Group.y + (Ysize/2);
			this.addChild(LoadingProgress);
		}
	
	}
	
	public function passData(...args){
		SWFContent.passData(args);
	}

	}
}