﻿/*ClassifierBase soll eine Basis Klasse für Klassen sein die mit Klassifikation zu tun haben und 
grundsätzliche Rechenoperationen aus diesem Umfeld enthalten*/

package com.tools{
	
	import flash.display.*;
	import flash.geom.*;
	import flash.utils.*;
	
	public class ClassifierBase extends Sprite{
		
		private var Version:String;
		
		public function ClassifierBase(){
		Version = "18.07.2013"
		trace ("ClassifierBase V: " + Version) 
		}// Constructor close
		
		// distance3d gibt die EuklidischeDistanz zweier Punkte einem 3d Koordinatensystem zurück Lage sein den Abstand 
		// Eingangsvariablen : zwei Arrays der jeweiligen punkte mit x/y/z Koordinaten 
		public function distance3d(PointA:Array,PointB:Array):Number{
			var returnValue:Number;
			returnValue=  Math.sqrt(Math.pow((PointB[0]- PointA[0]),2)+Math.pow((PointB[1]- PointA[1]),2)+Math.pow((PointB[2]- PointA[2]),2));
			return returnValue;
		}
		
		public function distance2d(PointA:Array,PointB:Array):Number{
			var returnValue:Number;
			returnValue =  Math.sqrt(Math.pow(PointB[0]- PointA[0],2)+Math.pow(PointB[1]- PointA[1],2));
			//trace("Distance "+returnValue);
			return returnValue;
		}
		
		// returnValuesFor gibt die Werte einer Bitmap an bestimmten Koordinaten als Array zurück
		// Eingangsvariablen : Bimtap und ein 2 dimensionales Array mit [x,y].
		public function returnValuesFor(inBitmap:Bitmap,PosArray:Array):Array{
			var returnArray:Array = new Array();
			for (var i = 0; i<PosArray.length;i++){
				var tempValue:uint;
				tempValue=inBitmap.bitmapData.getPixel(PosArray[i][0],PosArray[i][1]);
				returnArray.push(tempValue);
			}
			return returnArray;
		}
		
		
		// colValueToRGB transformiert einen BitmapDataFarbwert in einen RGB Farbwert
		public function colValueToRGB(inValue:uint):Array{
			var returnArray:Array = new Array();
			var R:uint;
			var G:uint;
			var B:uint;
			
			R = (inValue & 0xff0000) >> 16;
			G = (inValue & 0xff00) >> 8;
			B =  inValue & 0xff;
			
			returnArray[0] = R;
			returnArray[1] = G;
			returnArray[2] = B;
			return returnArray;
		}
		
		
		// formt ein Array aus [R,G,B] in einen Farbwert um
		public function colRGBToValue(inArray:Array):uint{
			var returnValue:uint;
			returnValue =  inArray[0] << 16 | inArray[1] << 8 | inArray[2];
			return returnValue;
		}
		
		// returnClassImage gibt ein Bitmap Objekt zurück in dem die als übergeenen Pixelwerte in der gewünschten Farbe markiert sind
		// Eingangsvariablen : Bitmap und ein 2 dimensionales Array mit [x,y] und ein ARGB Farbwert
		public function returnClassImage(inBitmap:Bitmap,inArray:Array,color:uint):Bitmap{
			inBitmap.bitmapData.lock();
			for (var i = 0; i<inArray.length;i++){
				inBitmap.bitmapData.setPixel32(inArray[i][0],inArray[i][1],color);
				
			}
			inBitmap.bitmapData.unlock();
			return inBitmap;
		}
		
		// returnBitChannelToIntArray  ließt einen kanal eines Bitmaps in ein Integer Array und gibt dieses zurück
		// Übergeben werden das Bitmap und eine Angabe über den Kanal in Hexformat R:0xff, G:0xffff, B: 0xffffff 
		// falls 32 Bit ausgelesen werden : Alpha 0xff und alle anderen um einen verschoben;
		
		
		public function returnBitChannelToIntArray(inBitmap:Bitmap,Channel:uint):Array{
		var returnArray:Array = new Array();
			for (var row:int=0;row<inBitmap.height;++row){
				for (var col:int=0;col<inBitmap.width;++col){
					var pixelValue:int;
					pixelValue = inBitmap.bitmapData.getPixel32(col,row) & Channel
					returnArray.push(pixelValue);
				}
			}
			
			return returnArray;
		}
		
		// Gibt ein Array aus (BitmapData) Farbwerten eines Bitmaps zurück 
		public function returnBitmapToArray(inBitmap:Bitmap):Array{
		var returnArray:Array = new Array();
			for (var row:int=0;row<inBitmap.height;++row){
				for (var col:int=0;col<inBitmap.width;++col){
					var pixelValue:uint;
					pixelValue = inBitmap.bitmapData.getPixel32(col,row);
					returnArray.push(pixelValue);
				}
			}
			
			return returnArray;
		}
		
		
		
		public function returnBitDataChannelToIntArray(inBitmapData:BitmapData,Channel:uint,W:int,H:int):Array{
		var returnArray:Array = new Array();
		
			for (var row:int=0;row<H;row++){
				for (var col:int=0;col<W;col++){
					var pixelValue:int;
					pixelValue = inBitmapData.getPixel32(col,row) 
						switch (Channel){
							case 0xff0000:
							pixelValue =  (pixelValue & 0xff0000) >> 16;
							break;
							case 0xff00:
							pixelValue =  (pixelValue & 0xff00) >> 8;
							break;
							case 0xff:
							pixelValue =  pixelValue & 0xff;
							break;
						}
					returnArray.push(pixelValue);
				}
			}
			return returnArray;
		}
		
		// Liefert ein Array mit den Integer Werten eines Bildes aus enem bestimmten Kanal
		
		public function returnPixChannelToIntArray(inBitmap:Bitmap,inArray:Array,Channel:uint):Array{
		var returnArray:Array = new Array();
				for (var i:int=0;i<inArray.length;i++){
					var pixelValue:uint;
					pixelValue = inBitmap.bitmapData.getPixel32(inArray[i][0],inArray[i][1]) & Channel
					returnArray.push(pixelValue);
				}
			return returnArray;
		}
		
		public function returnBDPixChannelToIntArray(inBitmapData:BitmapData,inArray:Array,Channel:uint):Array{
		var returnArray:Array = new Array();
				for (var i:int=0;i<inArray.length;i++){
					var pixelValue:uint;
					pixelValue = inBitmapData.getPixel32(inArray[i][0],inArray[i][1]) & Channel
					returnArray.push(pixelValue);
				}
			return returnArray;
		}
		
	 // liefert den Grauwert eines übergebnen farbwertes im entsprechnden Kanal (0xff,0x00ff,0x0000ff)
	public function returnIntValue(inValue:uint,Channel:uint){
		var returnValue:int = inValue & Channel
		return returnValue;
	}
	
	
	 // gibt ein Bitmap aus einen Integer Array zurück 
	
	public function returnBitmapFromArray(IntArray:Array,w:int,h:int):Bitmap {
			var returnBitmap:Bitmap
			var returnBitmapData:BitmapData
			var Region:Rectangle;
			
			trace("translating Array to Bitmap");
			trace(IntArray.length);
			var bytecount:int = 0;// variable zur festlegung der aktuellen Stelle im Bytearray
			Region= new Rectangle(0,0,w,h);
			var genByteArray:ByteArray = new ByteArray();
			genByteArray.length=IntArray.length*4;
			returnBitmapData =new BitmapData(w,h);
			
			trace("Hoch:"+h);
			trace("Breit:"+w);
			for (var b=0; b <=  IntArray.length; b++) {
				if ( b>0) {
					bytecount = bytecount +4;
				}
				
				genByteArray[bytecount]=255;
				genByteArray[bytecount+1]=IntArray[b];
				genByteArray[bytecount+2]=IntArray[b];
				genByteArray[bytecount+3]=IntArray[b];
			}
			
			returnBitmapData.setPixels(Region,genByteArray);
			returnBitmap = new Bitmap(returnBitmapData);
			
			return returnBitmap;
		}
		
	
	// Ein integer Array das zuvor aus einem Bildkanal erzeugt wurde kann hier gestreched werden. 
	// Das Streching erfolgt linerar unter Einbeziehung der Standardabweichung.
		
	public function returnStretchedArray(ArraytoStretch:Array):Array {
			// die Werte fürs Stretching werden im eingehenden Array berrechnet und dann in WorkArray geschrieben und angezeigt
			var WorkArray:Array=new Array(ArraytoStretch.length);
			trace("Afterpassing:"+ArraytoStretch[45]);
			trace("Length Afterpassing: "+ArraytoStretch.length);


			var f: int=0;
			var h: int=0;
			var i: int=0;
			var Steig:Number;
			var yachs:Number;
			var sum:Number=0;
			var sum2:Number;
			var sumSTABW:Number = 0;
			var STABW:Number = 0;
			var toAdd:Number = 0;
			var mw:Number = 0;
			var max:Number;
			var min:Number;
			var setValue:int; //Im Stretching verwendeter Zwischenwert

			max=ArraytoStretch[0];
			min=ArraytoStretch[0];
			
			trace ("Testsumme: "+ (sum+ArraytoStretch[h]));
			
			for (h;h<ArraytoStretch.length;h++){
			sum2  =  ArraytoStretch[h];
			sum = sum +sum2;
						}
			
			trace ("Summe: "+sum);
			trace (typeof(sum));
			
			mw = sum / ArraytoStretch.length;
			
				
			trace ("Mittelwert:"+mw);
			
		  for (h=0; h<ArraytoStretch.length; ++h) {
				if (ArraytoStretch[h]>=0){
				toAdd=ArraytoStretch[h]-mw;
					if (toAdd<0){
						toAdd=toAdd*-1;
					}
				
				}
				else if(ArraytoStretch[h]<0){
				toAdd=((ArraytoStretch[h])*-1)-mw;
					if (toAdd<0){
						toAdd=toAdd*-1;
					}
				}
				sumSTABW=sumSTABW+toAdd;
			}
			
			trace ("SummeStabw: "+sumSTABW);
			
			STABW = sumSTABW/ArraytoStretch.length;
			
			trace ("StandardAbsweichung: "+STABW);
			
				min = mw-(1*STABW)
			max = mw+(3.5*STABW)
			trace ("min: "+min+"max: "+max);
		
			Steig = (255-0) / (max - min);
			yachs = 0-Steig*min;
			
			for (i=0; i<ArraytoStretch.length; ++i) {
				setValue=ArraytoStretch[i]*Steig+yachs;
				if (setValue>255){
					WorkArray[i]=255}
				else if (setValue<0){
					WorkArray[i]=0}
				else {WorkArray[i]=setValue}
				//WorkArray[i]=WorkArray[i]*Steig+yachs;
			}
			
			sum = 0;
			sumSTABW = 0;
			STABW = 0;
			toAdd = 0;
			mw = 0;
			
			return WorkArray;
		}
		
		
		
	// aus zwei Werte Arrays wird ein MeanVector zurückgegeben
	
	public function returnMeanVector(InArray_A:Array,InArray_B:Array):Array{
		var Sum_1:uint;
		var Sum_2:uint;
		var MeanVect:Array = new Array();; 
		var steps:uint=InArray_A.length
			for(var i=0;i<steps;i++){
				var toAdd_1:uint=InArray_A[i];
				var toAdd_2:uint=InArray_B[i];
				Sum_1 = toAdd_1+Sum_1;
				Sum_2 = toAdd_2+Sum_2;
			}
		MeanVect[0]=Sum_1/steps;
		MeanVect[1]=Sum_2/steps;
		trace ("MEANV "+MeanVect[0]);
		return MeanVect;
	}
	
	// Gibt den Mittelwert einer Zahlenreihe zurück
	
	public function returnMean(inArray:Array):uint{
		var returnMean:int;
		var sum:int = 0;
		for(var i = 0;i<inArray.length;i++){
		sum = sum+ inArray[i];
		}
		returnMean = sum/inArray.length;
		
		return returnMean;
	}
	
	public function returnProductArray(inArrayA:Array,inArrayB:Array):Array{
		var returnArray:Array;
		returnArray = new Array();
		for(var i = 0;i<inArrayA.length;i++){
		returnArray[i] = inArrayA[i]*inArrayB[i];
		}
		
		return returnArray;
	}
	
	
	
	public function returnCovarianceMatrix(covar:Array,Var:Array){
	var returnArray:Array = new Array();
		
		trace ("COVARTEST" + " " + covar+" " + " "+ Var)		
		returnArray[0] = [Number(0),Number(0)];
		returnArray[1] = [Number(0),Number(0)];
		
		for(var row = 0;row<covar.length;row++){
			for(var col = 0;col<covar.length;col++){
				if (col==row){
				returnArray[row][col] = Var[col];
				}
				else{	
				returnArray[row][col] = covar[row];
				}
			}
		}
		return returnArray;
	}
	
 public function returnCovariance(ValuesX:Array,ValuesY:Array):Number{
		var CoVar:Number;
		var SumX:Number;
		var MeanX:Number;
		var SumY:Number;
		var MeanY:Number;
		var ProdXYArray:Array;
		var SumXY:Number;
		var sum:Number = 0;
		
		ProdXYArray = returnProductArray(ValuesX,ValuesY);
		MeanX = returnMean(ValuesX);
		MeanY = returnMean(ValuesY);
		
		SumX = returnSum(ValuesX);
		SumY = returnSum(ValuesY);
		SumXY = returnSum(ProdXYArray);
		
		trace ("SumX "+ SumX);
		trace ("SumY "+ SumY);
		trace ("SumXY "+ SumXY);
		
		trace ("MW_X :" +returnMean(ValuesX) + "MW_Y :" + returnMean(ValuesY))

		
		for(var i = 0;i<ValuesX.length;i++){
		sum = sum+((ValuesX[i]-MeanX)*(ValuesY[i]-MeanY))
		}
		
		trace ("Summme "+ sum);
		trace ("n "+ ValuesX.length);
		
		CoVar = sum/ValuesX.length;
		
		CoVar = Math.round(CoVar*10000)/10000 ;
		
		//CoVar = CoVar/ValuesX.length-1;
		
		trace ("CovarIst " + CoVar);
		
		return CoVar;
	}
	
	// Gibt die ein aufsummiertes Array zurück
	
	public function returnSum(inArray:Array):Number{
		var sum:Number = 0;
		for(var i = 0;i<inArray.length;i++){
		sum = sum+ inArray[i];
		}
		return sum;
	}
	
	// transponiert eine Matrize
	
	public function returnTranspondMatrix(inArray:Array):Array{
		var sum:uint = 0;
		var returnArray = new Array();
		returnArray = createMatrix(inArray.length);
		for(var row = 0;row<inArray.length;row++){
		returnArray[row] = getCol(inArray,row);
		}
		return returnArray;
	}
	
	//	gibt die Determinante einer 2er Matrize zurück
	
	public function returnDeterminant_2(inArray:Array):Number{
		var determinant:Number
		 determinant = (inArray[0][0]*inArray[1][1])-(inArray[0][1]*inArray[1][0]);
		return determinant;
	}
	
//	invertiert eine 2er Matrize
	
	public function returnInvertMatrix_2(inArray:Array):Array{
		var Det:Number = 1/(returnDeterminant_2(inArray));
		
		
		
		//var tempArray:Array = new Array();
	
		var returnArray:Array = new Array();
		//tempArray = createMatrix(2);
		returnArray = createMatrix(2);
		returnArray[0] = [inArray[1][1],(inArray[0][1]*-1)];
		returnArray[1] = [(inArray[1][0]*-1),inArray[0][0]];
		
		
		//trace ("returnArray" +returnArray);
		
		
		returnArray[0][0] = returnArray[0][0] * Det;
		returnArray[0][1] = returnArray[0][1] * Det;
		returnArray[1][0] = returnArray[1][0] * Det;
		returnArray[1][1] = returnArray[1][1] * Det;
		
		return returnArray;
	}
	
	
	
	
	// gibt eine Reihe einer Matrize zrück
	
	public function getRow(inArray:Array,row:int){
		var returnArray:Array;
		for(var i = 0;i<inArray.length;i++){
		returnArray.push(inArray[row][i])
		}
		return returnArray;
	}
	
	// gibt eine Spalte einer Matrize zrück
	
	public function getCol(inArray:Array,col:int){
		var returnArray:Array;
		returnArray = new Array();
		for(var i = 0;i<inArray.length;i++){
		returnArray.push(inArray[i][col])
		}
		return returnArray;
	}
		
	
	// legt eine leer (0) matrize mit dim ausmaßen an
	
	public function createMatrix(dim:int):Array{
		var returnMatrix:Array = new Array();
		var tempArray:Array = new Array();
		
		var fillwith:Number = 0;
		
		for(var row = 0;row<dim;row++){
		tempArray[row] = fillwith;
		}
		
		for (var col = 0;col<dim;col++){
		returnMatrix[col]=tempArray;
		}
			
		return returnMatrix;
	}
	
	// gibt das Skalarprodukt zweier vektoren zurück
	
	public function returnScalar(inArrayA:Array,inArrayB:Array):Number{
		var scalar:Number;
		var addArray:Array = new Array();
		
		for(var i = 0;i<inArrayA.length;i++){
		addArray.push(inArrayA[i]*inArrayB[i])
		}
		
		scalar = returnSum(addArray);
		
		return scalar;
	}
	
	// subtrahiert zwei Arrays
	
	public function returnSubstArray(inArrayA:Array,inArrayB:Array):Array{
		
		var returnArray:Array = new Array();
		
		for(var i = 0;i<inArrayA.length;i++){
		returnArray.push(Math.round((inArrayA[i]-inArrayB[i])*10000)/10000);
		}
		
		return returnArray;
	}
	
	// gibt das produkt einer Matrix und eines Vektors zurück
	
	public function returnMatrixVectorProd(inMatrix:Array,inVector:Array):Array{
		
		var returnArray:Array = new Array();
		
		for (var col = 0;col<inMatrix.length;col++){
			var tempArray:Array = new Array(); 
			for(var row = 0;row<inMatrix.length;row++){
				
				
				tempArray.push(Number(Math.round((inMatrix[col][row]*inVector[row])*10000)/10000));
				//trace(tempArray);
			}
			returnArray[col] = returnSum(tempArray);
		}
		
		
		return returnArray;
	}
	
	public function returnAmount(inValue:Number){
	
	var returnValue:Number = Math.sqrt((inValue*inValue));
	
	return returnValue;
	
	}
	
	// Gibt die [Steigung,Y-AchsenAbschnitt] zurück. Für ein Array aus:[x1,y1,x2,y2] 
	public function returnLinearFunction(MinMaxArray:Array):Array{
		var Slope:Number;
		var yInters:Number;
		
	 
		 Slope = (MinMaxArray[3]- MinMaxArray[1]) / (MinMaxArray[2]- MinMaxArray[0]);
		 yInters = ((MinMaxArray[0] * MinMaxArray[3]) - (MinMaxArray[2] * MinMaxArray[1]))/(MinMaxArray[0]-MinMaxArray[2]);
		//yInters = MinMaxArray[3]*Slope+MinMaxArray[1];
		var returnArray:Array = new Array(Slope,yInters);
		
		trace ("EINGANG: " + MinMaxArray +" FUNCTION : " +returnArray);
		
		return returnArray;
	
	}
	
		// Formt die Werte eines Arrays nach lFunction[slope,yIntersect] um
	public function linearArrayTransform(inArray:Array,lFunction:Array):Array{
		var returnArray:Array = new Array();
		for(var i=0;i < inArray.length;i++){
			returnArray.push((lFunction[0]*inArray[i])+lFunction[1]);
		}
		return returnArray;
	}
		 
	
	public function returnMinMaxPos(inArray:Array,MinMax:String){
	
	var returnVar:int
	var testVar:uint
	
		if (MinMax == "max"){
			testVar = inArray[0];
			for (var i = 0;i <inArray.length;i++){
				if (inArray[i] > testVar){
				returnVar = i;
				}
			}
		}
		
		if (MinMax == "min"){
			testVar = inArray[0];
			for (var i = 0;i <inArray.length;i++){
				if (inArray[i] < testVar){
				returnVar = i;
				}
			}
		}
		
		//trace ("InArray "+ inArray + "Posof"+MinMax +" = " +returnVar);
		
		
		return returnVar;

	}
	
	
	// gibt Miniumum oder Maxiumum eines Array zurück
	public function returnMinMax(inArray:Array,MinMax:String):int{
	
	var returnVar:int
	var testVar:int
	
		if (MinMax == "max"){
			testVar = inArray[0];
			for (var i = 0;i <inArray.length;i++){
				if (inArray[i] > testVar){
				testVar = inArray[i];
				returnVar = inArray[i];
				}
			}
		}
		
		if (MinMax == "min"){
			testVar = inArray[0];
			for (var i = 0;i <inArray.length;i++){
				if (inArray[i] < testVar){
				testVar = inArray[i];
				returnVar = inArray[i];
				}
			}
		}
		
		//trace ("InArray "+ inArray + " "+MinMax +" = " +returnVar);
		
		
		return returnVar;

	}

	// überführt eine Zahl entsprchend eine linearen funktion(funct[Steigung,YAchsenabschnitt])
 	public function linearTransformValue(inValue:Number,funct:Array):Number{
		//trace ("INVLAUE :"+ inValue);
		//trace ("Funct :"+ funct);
		var returnValue:Number;
		 returnValue = (inValue*funct[0])+funct[1];
		 //trace ("OUTVLAUE :"+ returnValue);
		 return returnValue;
	}
	
	// Gibt aus einem Array welches ein Bild repräsentiert einen Wert an X/Y zurück
	public function returnArrayValueAt(InArray:Array,W:int,H:int,xpos:int,ypos:int):Number{
		var ArrayPos:int = (ypos*W)-(W-xpos)+W;
		trace ("arpos:" +ArrayPos);
		var ReturnValue:Number = InArray[ArrayPos];
		return ReturnValue;
	}
	
	// Gibt die Stelle in einem ein Bild repräsentierendem Array zurück an welche den Wert für die angegebene x/y position hat in Abhängigkeit von width und heigth des Bildes
	public function returnArrayPos(W:int,H:int,xpos:int,ypos:int):int{
		var ArrayPos:int = (ypos*W)-(W-xpos)+W;
		trace ("XY POS:" +xpos +" "+ypos);
 		return ArrayPos;
	}
	
	// Ersetzt in einem Array werte die bestimmten Spannen entsprechen (Array: das Array, Vector: ein Vector aus dreistelligen Arrays(minimum, maximum, einzutragender Wert);
	public function replaceValues(inArray:Array,inVector:Vector.<Array>):Array{
		var returnArray:Array = inArray;
		for (var i:int=0; i<inVector.length;i++){
			for (var a:int=0; a <=inArray.length;a++){
				if (inArray[a]>=inVector[i][0] && inArray[a]<=inVector[i][1]){
					returnArray[a] = inVector[i][2];
				}
			}
		}
		return returnArray;
	}
	
					
	}// Class close
}// Package close