﻿// Zeigt das Histogramm eines übergebenen Bitmaps

package src.com.tools {
	
	import flash.events.*;
	import flash.display.*;
	import flash.net.URLRequest;
	import com.events.FISEvents;
	import flash.geom.*;
	import flash.utils.Timer;
	import flash.text.*;
	
	
	
	public class Histogram extends Sprite{
	
	private var Graph:ScatterPlot // Hier wirds angezeigt
	//private var InBitmap:Bitmap  //übergebene Bitmap
	private var BitmapIntArray:Array // Das integer Array aus dem Bitmap
	private var Calculate:ClassifierBase; 	// Für Bildoperationen
	private var CountArray:Array 				// Beinhaltet die Häufigkeiten der Werte 0 - 255 im Bild
	public var XArray:Array				// Ein Array mit 256 mit den Zahel 0 - 255 
	private var MaxCount:uint; // Maximalwert des Countarrays
	private var MinValue:int; // Kleinster Wert im Bildarray
	private var MaxValue:int; // Grösster Wert im Bildarray
	private var Canvas:Shape; // Container für Histogramm-Zeichnung
	private var GhostCanvas:Shape; // der Geistergraph
	private var Table:Shape; // der Geistergraph
	private var Table_mc:MovieClip; // der Geistergraph
	private var YScaleFactor:Number;
	public var HistLineColor:uint;
	public var HistLineThickness:uint;
	public var GraphLineColor:uint;
	public var GraphLineThickness:uint;
	public var StretchMode:Boolean; 		// Sollen Tools zum Stretching angeziegt werdens
	private var HighButtDraw:Shape;
	private var HighButt_mc:MovieClip;
	private var LowButtDraw:Shape;
	private var LowButt_mc:MovieClip;
	public var StretchData:Array;			// Die Daten für das Streching werden hier reingeschrieben [momentanesMin,MomentanesMax,geplantesMin,geplantesMax]
	
	private var HistFont:Font;
	private var HistFormat:TextFormat;
	
	private var NowLow:TextField;
	private var NowHigh:TextField;
	
	private var ThenLow:TextField;
	private var ThenHigh:TextField;
	
	
	
	
	// Übergeben werden das Bitmap und eine Angabe über den Kanal in Hexformat R:0xff, G:0xffff, B: 0xffffff 
	// falls 32 Bit ausgelesen werden : Alpha 0xff und alle anderen um einen verschoben;

	public function Histogram(inBitmap:Bitmap,Channel:uint,sm:Boolean = false, gc:uint=0x000000,hc:uint = 0x0000ff){
		trace ("Histogramm wird angelegt");
		
		Calculate = new ClassifierBase();
		
		StretchMode = sm;
		
		HistLineColor = hc;
		HistLineThickness = 3;
		
		GraphLineColor = gc;
		GraphLineThickness = 3
		
		BitmapIntArray = Calculate.returnBitChannelToIntArray(inBitmap,Channel);
		
		Canvas=new Shape();
		//addChild(Canvas);
		xValues();
		histogramData();
		
		YScaleFactor = 200 / MaxCount;
		
		GraphDraw();
		HistogrammDraw();
		
		if (StretchMode){
		initStretch();
		}
	
	}// Constructor close
	
	
	private function initStretch(){
		trace ("STRETCH MODE");
		drawHighButton();
		drawLowButton();
		HighButt_mc.x = MaxValue;
		HighButt_mc.y = 200;
		HighButt_mc.scaleX = 1.2;
		HighButt_mc.scaleY = 1.2;
		HighButt_mc.buttonMode = true;
		HighButt_mc.addEventListener(MouseEvent.MOUSE_DOWN, moveButt);
		HighButt_mc.addEventListener(MouseEvent.MOUSE_UP, releaseButt);
		HighButt_mc.addEventListener(MouseEvent.MOUSE_OUT, releaseButt);
		
		LowButt_mc.x = MinValue;
		LowButt_mc.y = 200;
		HighButt_mc.scaleX = 1.3;
		HighButt_mc.scaleY = 1.3;
		LowButt_mc.buttonMode = true;
		LowButt_mc.addEventListener(MouseEvent.MOUSE_DOWN, moveButt);
		LowButt_mc.addEventListener(MouseEvent.MOUSE_UP, releaseButt);
		LowButt_mc.addEventListener(MouseEvent.MOUSE_OUT, releaseButt);
		
		StretchData = new Array(MinValue,MaxValue,MinValue,MaxValue);
		trace ("STRETCH DATA: "+StretchData);
		GhostCanvas=new Shape();
		
		HistFont = new Arial_type();
		HistFormat = new TextFormat();
		HistFormat.font = HistFont.fontName;
		HistFormat.color = 0x2DC22C;
		HistFormat.size = 15;
		
		drawTable();
		Table_mc.x = 5;
		Table_mc.y = -30;
	}
	
	private function drawLowButton(){
		LowButtDraw = new Shape();
		LowButtDraw.graphics.beginFill(0xFFFFFF,0.01);
		LowButtDraw.graphics.drawRect(-5,-5,35,35);
		LowButtDraw.graphics.endFill();
		LowButtDraw.graphics.beginFill(HistLineColor);
		LowButtDraw.graphics.moveTo(15,0);
		LowButtDraw.graphics.lineTo(30,15);
		LowButtDraw.graphics.lineTo(0,15);
		LowButtDraw.graphics.lineTo(15,0);
		LowButtDraw.graphics.endFill();
		LowButtDraw.graphics.beginFill(0x2DC22C);
		LowButtDraw.graphics.moveTo(15,3);
		LowButtDraw.graphics.lineTo(27,15);
		LowButtDraw.graphics.lineTo(3,15);
		LowButtDraw.graphics.lineTo(15,3);
		LowButtDraw.graphics.endFill();
		
		LowButtDraw.x = -15
		
		LowButt_mc = new MovieClip();
		addChild(LowButt_mc);
		
		LowButt_mc.addChild(LowButtDraw);
		
	}
	
	private function drawHighButton(){
		
		HighButtDraw = new Shape();
		HighButtDraw.graphics.beginFill(0xFFFFFF,0.01);
		HighButtDraw.graphics.drawRect(-5,-5,35,35);
		HighButtDraw.graphics.endFill();
		HighButtDraw.graphics.beginFill(HistLineColor);
		HighButtDraw.graphics.moveTo(15,0);
		HighButtDraw.graphics.lineTo(30,15);
		HighButtDraw.graphics.lineTo(0,15);
		HighButtDraw.graphics.lineTo(15,0);
		HighButtDraw.graphics.endFill();
		HighButtDraw.graphics.beginFill(0xE04D0E);
		HighButtDraw.graphics.moveTo(15,3);
		HighButtDraw.graphics.lineTo(27,15);
		HighButtDraw.graphics.lineTo(3,15);
		HighButtDraw.graphics.lineTo(15,3);
		HighButtDraw.graphics.endFill();
		HighButtDraw.x = -15
		HighButt_mc = new MovieClip();
		addChild(HighButt_mc);
		
		
		
		HighButt_mc.addChild(HighButtDraw);
	
	}
	
	
	private function drawTable(){
		Table = new Shape;
		Table_mc = new MovieClip();
		addChild(Table_mc);
		
		Table.graphics.beginFill(HistLineColor,0.5);
		Table.graphics.drawRect(0,0,125,25);
		Table.graphics.endFill();
		Table.graphics.beginFill(0xff0000,0.5);
		Table.graphics.drawRect(126,0,125,25);
		Table_mc.addChild(Table);
		
		
		var Min1:TextField = new TextField();
		Min1.width = 25;
		Min1.height = 20;
		Min1.x = 2;
		Min1.y = 2;
		Min1.text = "min";
		setFormat(Min1,0x000000,11);
		Table_mc.addChild(Min1);
		
		var Max1:TextField = new TextField();
		Max1.width = 25;
		Max1.height = 20;
		Max1.x = 60;
		Max1.y = 2;
		Max1.text = "max";
		setFormat(Max1,0x000000,11);
		Table_mc.addChild(Max1);
		
		var Min2:TextField = new TextField();
		Min2.width = 25;
		Min2.height = 20;
		Min2.x = 128;
		Min2.y = 2;
		Min2.text = "min";
		setFormat(Min2,0x000000,11);
		Table_mc.addChild(Min2);
		
		var Max2:TextField = new TextField();
		Max2.width = 25;
		Max2.height = 20;
		Max2.x = 186;
		Max2.y = 2;
		Max2.text = "max";
		setFormat(Max2,0x000000,11);
		Table_mc.addChild(Max2);
		
		NowLow = new TextField();
		
		NowLow.width = 33;
		NowLow.height = 20;
		NowLow.backgroundColor = 0xffffff;
		NowLow.background = true;
		NowLow.x = 26;
		NowLow.y = 3;
		setFormat(NowLow,0x000000,15);
		Table_mc.addChild(NowLow);
		
	    NowHigh = new TextField();
		NowHigh.width = 33;
		NowHigh.height = 20;
		NowHigh.background = true;
		NowHigh.x = 90;
		NowHigh.y = 3;
		Table_mc.addChild(NowHigh);
		
		ThenLow = new TextField();
		ThenLow.width = 33;
		ThenLow.height = 20;
		ThenLow.background = true;
		ThenLow.x = 151;
		ThenLow.y = 3;
		Table_mc.addChild(ThenLow);
		
		ThenHigh = new TextField();
		ThenHigh.width = 33;
		ThenHigh.height = 20;
		ThenHigh.background = true;
		ThenHigh.x = 215;
		ThenHigh.y = 3;
		Table_mc.addChild(ThenHigh);
	}
	
	private function setFormat(InField:TextField,col:uint,si:uint){
		HistFormat.color = col;
		HistFormat.size = si;
		InField.setTextFormat(HistFormat);
		InField.embedFonts=true;
		InField.selectable=false;
	}
	
	
	private function histogramData(){ // erzeugt ein Array mit Häufigkeitsverteilung für das Bild
			CountArray = new Array();
			
			for (var k=0; k<256; k++) {
			CountArray.push(0);
			}
			
		var i : int = -1;
		//var n : uint = 0;

				while( ++i < BitmapIntArray.length ){
   					var a = BitmapIntArray[i];
  					CountArray[a]=(CountArray[ a ] + 1)
   				}
		//trace( countArray );
		trace ("Array Länge: "+XArray);
		trace ("CountArray Länge: " + CountArray);
		
		MaxCount = 0;
		
		for (h=0;h<CountArray.length;++h){
				if (CountArray[h]>MaxCount){
				MaxCount = CountArray[h];				
				}
			}
			trace ("maxC="+MaxCount);
		
		MaxValue = Calculate.returnMinMax(BitmapIntArray,"max");
		MinValue = Calculate.returnMinMax(BitmapIntArray,"min");
		
		trace ("Max "+MaxValue);
		trace ("Min "+MinValue);
		
		
	}
	
	private function xValues(){
		XArray = new Array();
		
		for (var k=0; k<256; k++) {
			XArray.push(k);
		}
	}
	
	
	private function GraphDraw(){
		Canvas.graphics.lineStyle(GraphLineThickness,GraphLineColor);
		Canvas.graphics.moveTo(0,200);
		Canvas.graphics.lineTo(0,0);
		Canvas.graphics.moveTo(0,200);
		Canvas.graphics.lineTo(255,200);
	}
	
	private function HistogrammDraw(){

		var j : int = -1;
			while( ++j < CountArray.length ){
				if (CountArray[j] is int){
				Canvas.graphics.lineStyle(HistLineThickness,HistLineColor);
				Canvas.graphics.moveTo(XArray[j],200);
				Canvas.graphics.lineTo(XArray[j],200-(CountArray[j]*YScaleFactor));
				
			}
			
		}

						
	} //HistogrammDraw close
	
	public function updateHist(inBitmap:Bitmap){
	   try{removeChild(Canvas)}
	   catch(e:Error){};
		
		GhostCanvas.graphics.clear();
	   Canvas.graphics.clear();
	   BitmapIntArray = Calculate.returnBitChannelToIntArray(inBitmap,0xff);
		
	
		xValues();
		histogramData();
		
		YScaleFactor = 200 / MaxCount;
		
		
		GraphDraw();
		HistogrammDraw();
		addChild(Canvas);
		
		if (StretchMode){
		HighButt_mc.x = MaxValue;
		HighButt_mc.y = 200;
		
		LowButt_mc.x = MinValue;
		LowButt_mc.y = 200;
		
		StretchData = [MinValue,MaxValue,MinValue,MaxValue];
		updateStretchText();
		
		}
	}
	
	private function moveButt(e:MouseEvent){
		var BoundRect:Rectangle = new Rectangle(0,199.5,255,0.5);
		addChild(e.currentTarget);
		e.currentTarget.startDrag(false,BoundRect);
		e.currentTarget.addEventListener(MouseEvent.MOUSE_MOVE,drawGhostHist);
	}
	
	private function releaseButt(e:MouseEvent){
		e.currentTarget.stopDrag();
		e.currentTarget.removeEventListener(MouseEvent.MOUSE_MOVE,drawGhostHist);
		StretchData[2] = LowButt_mc.x;
		StretchData[3] = HighButt_mc.x;
		trace (StretchData);
		//this.dispatchEvent(new FISEvents(FISEvents.DATA_READY,[StretchData[0],StretchData[2],StretchData[1],StretchData[3]]));
	}
	
	private function drawGhostHist(e:MouseEvent){
		var stretchFunction:Array
		StretchData[2] = LowButt_mc.x;
		StretchData[3] = HighButt_mc.x;
		stretchFunction = Calculate.returnLinearFunction([StretchData[0],StretchData[2],StretchData[1],StretchData[3]]);
		trace (StretchData);
		trace (stretchFunction);
		GhostHistogrammDraw(stretchFunction);
		updateStretchText();
	}
	
	private function GhostHistogrammDraw(functArray:Array){
		 try{removeChild(GhostCanvas)}
	   catch(e:Error){};
		GhostCanvas.graphics.clear();
		var j : int = -1;
			while( ++j < CountArray.length ){
				if (CountArray[j] is int){
				GhostCanvas.graphics.lineStyle(HistLineThickness,0xff0000,0.2);
				GhostCanvas.graphics.moveTo(XArray[j]*functArray[0]+functArray[1],200);
				GhostCanvas.graphics.lineTo(XArray[j]*functArray[0]+functArray[1],200-(CountArray[j]*YScaleFactor));
				
			}
			
		}
		
		addChild(GhostCanvas);
						
	} //HistogrammDraw close
	
	private function updateStretchText(){
		NowLow.text = int(StretchData[0]);
		NowHigh.text = int(StretchData[1]);
		ThenLow.text = int(StretchData[2]);
		ThenHigh.text = int(StretchData[3]);
		
		setFormat(NowLow,0x000000,15);
		setFormat(NowHigh,0x000000,15);
		setFormat(ThenLow,0x000000,15);
		setFormat(ThenHigh,0x000000,15);
	}
	
	} //Class Close
} // Package close
