﻿/*NDVI_Calculator Berechnet ein NDVI bild aus auf die Flächen abgelegten Bildern.*/

package  com.tools {
	
import com.events.SatCalcEvent;
import flash.display.Sprite;
import flash.display.*;
import flash.geom.*;
import flash.text.*;
import flash.events.*;
import FISEvents;
import com.utilities.*;
import flash.ui.Mouse;
import flash.utils.*;
import flash.net.*;


	public class NDVICalculator extends SatCalcDisplay {
	
	public var OutAt_X:int;					// an welche Stage Koordinaten werden die Overlays ausgegeben
	public var OutAt_Y:int;
	public var NDVICalc_mc:MovieClip; 
	public var HasDropFields:Boolean;
	public var HasGhosts:Boolean;
	public var DropFields:Array;
	public var IRZaehl_koord:Point;
	public var IRNenn_koord:Point;
	public var RZaehl_koord:Point;
	public var RNenn_koord:Point;
	public var ToolDims:Array;				// Die Abmessungen der Tools. Wird im SatCalculator benötigt um die Positionierung vorzunehmen
	public var Ident:String;				// Gleicht dem Namen des Objektes im Satcalculator
	private var Data_A:Array;			// Array mit den Daten des IRZ
	private var Data_B:Array;			// Array mit den Daten des RZ
	public var NDVIArray:Array;			// Array enthält NDVIDaten;

	private var MessageTimer:Timer;		// Die Rückmeldung wenn NDVI berechnet wird braucht ein wenig Vorsprung, weil sie sonst nicht angezeigt wird
	
	private var DataWidth_:int;
	private var DataHeight_:int;
	private var RMetaData:Array;	// MetaDaten zum erzeugeten ZaehlerBild
	private var IRMetaData:Array;	// MetaDaten zum erzeugeten ZaehlerBild
	private var NDVIMetaData:Array;	// MetaDaten zum erzeugeten NDVI BILD
	
	private var Calculator:ImageCalc;
	public var IRZaehlGhost:Bitmap;			// Der Bitmap "Ghost" auf IRZahle 
	public var RZaehlGhost:Bitmap;			// Der Bitmap "Ghost" auf IRZahle 
	public var IRNennGhost:Bitmap;			// Der Bitmap "Ghost" auf IRZahle 
	public var RNennGhost:Bitmap;			// Der Bitmap "Ghost" auf IRZahle 
	public var NameOfData:Array;			// Die Namen der in der Rechung verwendeten Clips kommen hier rein
	private var AllocationStatus:Array;		// Zwiestellliges Array in dem abglegt ist ob Data_A oder B belegt sind
	
	
	
		public function NDVICalculator(outX:int,outY:int,varArr:Array,ID:String){
			
			Ident = ID;
			
			// Die Positionen der Dropflächen im Lokalen Objekt
			
			IRZaehl_koord = new Point(30,4);
			RZaehl_koord = new Point(100,4);
			IRNenn_koord = new Point(30,53);
			RNenn_koord = new Point(100,53);
			
			trace ("LOCALLLLLLLLLLLLLLLLLLLLRUNDE " +localToGlobal(IRZaehl_koord))
			
			// Das Array in dem alle relevanten Daten zu den DropFields gespeichert sind
			
			DropFields = new Array();

			HasDropFields = true;
			HasGhosts	= true;
			trace ("NDVICalculator INVOKED");
			
			OutAt_X=outX;
			OutAt_Y=outY;
			
			NDVICalc_mc = new NDVI_CALC;
			addChild(NDVICalc_mc);
			ToolDims = new Array();
			ToolDims[0] =[NDVICalc_mc.width,NDVICalc_mc.height];
			NDVICalc_mc.NDVI_mc.visible = false;
			NDVICalc_mc.NDVI_mc.gotoAndStop(1);
			NDVICalc_mc.NDVI_mc.buttonMode = true;
			NDVICalc_mc.NDVI_mc.addEventListener(MouseEvent.MOUSE_DOWN, messageAndStart);
			
			
			// NDVI_mc
			
			DropFields[0] = [Ident,"IRZaehl",IRZaehl_koord];
			DropFields[1] = [Ident,"RZaehl",RZaehl_koord];
			DropFields[2] = [Ident,"IRNenn",IRNenn_koord];
			DropFields[3] = [Ident,"RNenn",RNenn_koord];
			
			
			IRZaehlData = new Array();			
			RZaehlData = new Array();				
			IRNennData = new Array();	
			RNennData = new Array();	
			
			NameOfData = new Array();
			
			NDVIMetaData = new Array("Image_A","Image_B")
			
			
			this.addEventListener(SatCalcEvent.DATA_DROP,dataDropped);
			this.addEventListener(SatCalcEvent.DATA_DELETE,removeDataAndGhost);
			
			// Ghosts
			
			IRZaehlGhost = new Bitmap(new BitmapData(1,1));
			IRZaehlGhost.x= IRZaehl_koord.x;
			IRZaehlGhost.y= IRZaehl_koord.y;
			
			RZaehlGhost = new Bitmap(new BitmapData(1,1));
			IRZaehlGhost.x= RZaehl_koord.x;
			IRZaehlGhost.y= RZaehl_koord.y;
			
			IRNennGhost = new Bitmap(new BitmapData(1,1));
			
			
			RNennGhost = new Bitmap(new BitmapData(1,1));
			RNennGhost.x= RNenn_koord.x;
			RNennGhost.y= RNenn_koord.y;
			
			NDVIArray=new Array();
			
			AllocationStatus = new Array();
			AllocationStatus =[false,false];
			
			
			
			
		}// Constructor close
		
		// Das e.data array beinhaltet: Name des getroffenen Dropfields(HotDropField),DatenArray(recentArray),recentButton.Ghost_mc,recentButton.name,recentButton.DataWidth,recentButton.DataHeight,recentButton.kanal,recentButton.Resolution,recentButton.Unit,recentButton.datum]
		//															0						1							2				3					4						5							6					7					8				9				
		private function dataDropped(e:SatCalcEvent){
			//var GhostImage:Bitmap = e.data[2];
			var GhostImage:MovieClip = MovieClip(e.data[2]);
			//addChild(GhostImage);
			
			
			var isRelevant:Boolean = checkDropfields(e.data[0]);
			
			if (isRelevant == true){
				var DroppedOn:String = e.data[0];
				trace ("erhalte daten für: "+e.data[0]);
				trace ("Testdaten: "+e.data[1][1599]);
				switch (DroppedOn){
					
					case "IRZaehl":
					Data_A = e.data[1];
					AllocationStatus[0] = true;
					addGhost(GhostImage,DroppedOn);
					NameOfData.push([e.data[3],DroppedOn]);
					trace ("IRZaehlData wurde bestückt :"+ Data_A[1599] + " von " +NameOfData + " WH "+e.data[4]+" "+e.data[5]);
					DataWidth_=e.data[4];
					DataHeight_=e.data[5];
					IRMetaData = new Array(e.data[3],e.data[4],e.data[5],e.data[6],e.data[7],e.data[8],e.data[9]);
					break;
					
					case "RZaehl":
					Data_B = e.data[1];
					AllocationStatus[1] = true;
					trace ("RZaehlData wurde bestückt :"+ Data_B[1599]);
					addGhost(GhostImage,DroppedOn);
					NameOfData.push([e.data[3],DroppedOn]);
					DataWidth_=e.data[4];
					DataHeight_=e.data[5];
					RMetaData = new Array(e.data[3],e.data[4],e.data[5],e.data[6],e.data[7],e.data[8],e.data[9]);
					break;
					
					case "IRNenn":
					Data_A = e.data[1];
					AllocationStatus[0] = true;
					trace ("IRNennData wurde bestückt :"+ Data_A[1599]);
					addGhost(GhostImage,DroppedOn);
					NameOfData.push([e.data[3],DroppedOn]);
					DataWidth_=e.data[4];
					DataHeight_=e.data[5];
					IRMetaData = new Array(e.data[3],e.data[4],e.data[5],e.data[6],e.data[7],e.data[8],e.data[9]);
					break;
					
					case "RNenn":
					Data_B = e.data[1];
					AllocationStatus[1] = true;
					trace ("RNennData wurde bestückt :"+ Data_B[1599]);
					addGhost(GhostImage,DroppedOn);
					NameOfData.push([e.data[3],DroppedOn]);
					DataWidth_=e.data[4];
					DataHeight_=e.data[5];
					RMetaData = new Array(e.data[3],e.data[4],e.data[5],e.data[6],e.data[7],e.data[8],e.data[9]);
					break;
				}
				
				trace ("RMETA: "+ RMetaData);
				trace ("IRMETA: "+ IRMetaData);
				checkCalcButton();
			}
		}
		
		
		
		// fügt an der korrekten Stelle das GhostBitmap ein
		private function addGhost(GhBitm:MovieClip,DF:String){
			switch(DF){
				case "IRZaehl":
				dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhBitm,"IRZaehl",IRNenn_koord,"IRNenn"]));
				break;
				case "RZaehl":
				dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhBitm,"RZaehl",RNenn_koord,"RNenn"]));
				break;
				case "IRNenn":
				dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhBitm,"IRNenn",IRZaehl_koord,"IRZaehl"]));
				break;
				case "RNenn":
				dispatchEvent(new SatCalcEvent(SatCalcEvent.ADD_GHOST,[Ident,GhBitm,"RNenn",RZaehl_koord,"RZaehl"]));
				break;
			}
		}
		
		// Prüft ob ein Clip der vom Rechenfeld genommen wird Teil einer NDVI Rechnung war entfernt diesen Datensatz
		// und sendet das Signal an den SatCalculator den entsprechenden Ghost ebenfalls zu entfernen.
		
		private function removeDataAndGhost(e:SatCalcEvent){
			var toRemove:String = e.data;
			trace (toRemove + " soll fliegen");
			trace (NameOfData);
			for(var i=0;i<NameOfData.length;i++){
				if (NameOfData[i][0]==toRemove){
				trace (NameOfData[i][0] +" fliegt");
				removeData(NameOfData[i][1]);
				
				var opposingField:String = returnGhostFieldName(NameOfData[i][1]);
				trace ("OPPP " +opposingField);
				this.dispatchEvent(new SatCalcEvent(SatCalcEvent.REMOVE_GHOST,[NameOfData[i][1],opposingField]));
				NameOfData.splice(i,1);
				}
			}
		}
		
// Kombiniert die Metadatenarrays der eingangsdaten zu einem MetadatenArray ders Ergebnisbildes
		private function mergeMetaArray():Array{
			
			var returnArray:Array = new Array();
					
					// Prüfen auf Bildbreite
					if (RMetaData[1] == IRMetaData[1]){
						returnArray.push(RMetaData[1])
					}
						else if (RMetaData[1] > IRMetaData[1])
						{returnArray.push(RMetaData[1])}
							
						else if (RMetaData[1] < IRMetaData[1])
						{returnArray.push(IRMetaData[1])};
					
					// Prüfen auf Bildhöhe
					
					if (RMetaData[2] == IRMetaData[2]){
						returnArray.push(RMetaData[2])
					}
						else if (RMetaData[2] > IRMetaData[2])
						{returnArray.push(RMetaData[1])}
							
						else if (RMetaData[2] < IRMetaData[2])
						{returnArray.push(IRMetaData[2])};
					
					// Prüfen auf Namen
					
					//if (RMetaData[0] == IRMetaData[0]){
						var combineNames:String = "R:"+RMetaData[0] +"\n"+"IR:"+IRMetaData[0];
						returnArray.push(combineNames)
					//}
					//	else{returnArray.push("mismatch")}
					
					
					// Kanal kommt raus ist jetzt NDVI
					
					returnArray[3] = "NDVI";
					
					// Prüfen auf Auflösung
					if (RMetaData[4] == IRMetaData[4]){
						returnArray.push(RMetaData[4])
					}
						else{returnArray.push("mismatch")}
					
					// Prüfen auf Einheit
					
					if (RMetaData[5] == IRMetaData[5]){
						returnArray.push(RMetaData[5])
					}
						else{returnArray.push("mismatch")}
						
						// Prüfen auf Datum
					
					if (RMetaData[6] == IRMetaData[6]){
						returnArray.push(RMetaData[6])
					}
						else{returnArray.push("mismatch")}
						
				return returnArray;
	
	}
		
//		Gibt zum eingegeben Feldnamen den Namen des gegenüberliegenden Feldes zurück
		
		public function returnGhostFieldName(inString:String):String{
			var returnString:String
			switch(inString){
				case "IRZaehl":
					returnString = "IRNenn";
				break;
				case "RZaehl":
					returnString = "RNenn";
				break;
				case "IRNenn":
					returnString = "IRZaehl";
				break;
				case "RNenn":
					returnString = "RZaehl";
				break;
				
			}
			return returnString;
		}
		
		private function removeData(rem:String){
			switch (rem){
				case "IRZaehl":
				Data_A = new Array();
				AllocationStatus[0] = false;
				break;
				
				case "RZaehl":
				Data_B = new Array();
				AllocationStatus[1] = false;
				break;
				
				case "IRNenn":
				Data_A = new Array();
				AllocationStatus[0] = false;
				break;
				
				case "RNenn":
				Data_B = new Array();
				AllocationStatus[1] = false;
				break;
			}
			checkCalcButton();
	
		}
		
		// Ist der Calc Button in abhängigkeit vom Allocation Status Array sichtbar oder nicht
		
		private function checkCalcButton(){
			if (AllocationStatus[0]==true && AllocationStatus[1] == true){
				NDVICalc_mc.NDVI_mc.visible = true;
			}
			else {NDVICalc_mc.NDVI_mc.visible = false};
		}
		
		// 
		
		
		private function messageAndStart(e:MouseEvent){
			dispatchEvent(new SatCalcEvent(SatCalcEvent.AIR_MESSAGE,[true,"NDVI-Bild"+"\n"+" wird berechnet"]));
			MessageTimer = new Timer(100,1);
			MessageTimer.addEventListener(TimerEvent.TIMER_COMPLETE,calcNDVI);
			MessageTimer.start();
		}
		
		private function calcNDVI(e:TimerEvent){
			
														
			MessageTimer.removeEventListener(TimerEvent.TIMER_COMPLETE,calcNDVI);
			// Das Array welches an den SatCalc weitergegeben wird mit DatenArray und Metadaten und 
			var outArray:Array = new Array();
			trace ("Länge des DatenArray: "+Data_A.length);
			 var NDVI_Calc:ImageCalc = new ImageCalc(Data_A,Data_B,DataWidth_,DataHeight_);
			 NDVI_Calc.NDVI();
			 outArray =  mergeMetaArray();
			
			 trace ("OUTARRAY: " +  outArray);
			 //outArray.push(Array(NDVI_Calc.NDVIDataArray));
			
			 this.dispatchEvent(new SatCalcEvent(SatCalcEvent.DATA_DISPLAY,[NDVI_Calc.NDVIDataArray,outArray[0],outArray[1],outArray[2],outArray[3],outArray[4],outArray[5],outArray[6]]));
														//							Daten				width		height		Name		NDVI	Auflösung	 Einheit		Datum						
			for (var i=0;i<=NameOfData.length;i++){
			removeDataAndGhost(new SatCalcEvent(SatCalcEvent.DATA_DELETE,NameOfData[0][0]));
			}
			
			dispatchEvent(new SatCalcEvent(SatCalcEvent.AIR_MESSAGE,[false,""]));
			//removeDataAndGhost(new SatCalcEvent(SatCalcEvent.DATA_DELETE,NameOfData[1][0]));		
		}
	
		
		// Überprüft, ob das aktivierte Dropfield Teil des Tools ist
		private function checkDropfields(Dropfield:String){
			var returnVar:Boolean = false;
			var i:int
			while (i<DropFields.length){
				if (DropFields[i][1] == Dropfield){
					returnVar = true;
					break;
				}
				i++;
			}
			
			return returnVar;
		};
		
			
	} // Class Close

}//Package close
	

	
