﻿/*#############################################################
# 				ColImageLoad 								 ##
#														     ##
#Steuerung der RGB und Toleranz- abhängigen Pixelauswahl.    ##
#															 ##
#														     ##
#(c) 2008, Henryk Hodam ##
#############################################################*/



/* Die Klasse lädt ein Farbild und zeigt es an. Zusätzlich können Pixel die einem bestimmten Farbbereich entsprechen markiert werden.
 selectValue(rval:uint,gval:uint,bval:uint,tol:uint) - selektiert die Pixel die den übergebenen Werten entsprechen (rot, grün, blau, und eine Tolleranz)
 Showmarked()- zeigt die Pixel die bei selectValue() selektiert wurden im Bild an;
 clearMarkBmp() - löscht die angezeigten Pixel.
*/
package {
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	
	public class ColImageLoad extends Sprite {
		
		var OutputImage:Bitmap;//auszugebendes Bild
		var color:uint; //Einzulesender Farbwert
		var colorint:uint;// in integer umgewandelter Farbwert
		var ImageArray:Array; // Array für Bildbearbeitung
		var ImageArrayint:Array; // Array für Histogramm
		var ImageArrayByte:ByteArray;
		var markbmpData:BitmapData;
		var markbmp:Bitmap;//Bitmap auf der die Pixel markiert werden
		var Rcolval:uint;// Rotwert der zu markierenden Pixel
		var Gcolval:uint;// Grünwert der zu markierenden Pixel
		var Bcolval:uint;// Blauwert der zu markierenden Pixel
		var coltol:uint;// Wert des Tolleranzbereichs
		var PixRect:Rectangle;// Bereich zum einlesen des ByteArray
		public var Pixamount:uint;//Variable zur Zählung der markierten Pixel
		var canvas:Shape; // Container für Pixelmarkierung
		var W:int// Breite des Bildes
		var H:int// Höhe des Bildes
		var Area:TextField; //TExtfeld zur Ausgabe der Fläche
		
	public function ColImageLoad (Image:Bitmap){
			markbmpData=new BitmapData(370,370,true,0x00000000)
			markbmp = new Bitmap(markbmpData);
			canvas=new Shape();
			Area = new TextField();
			OutputImage = Image;
			Pixamount = 0;
			W=Image.width;
			H=Image.height;
			PixRect = new Rectangle(0,0,W,H)
			ImageArrayByte = OutputImage.bitmapData.getPixels(PixRect)
			addChild(OutputImage); 
	}
		
	public function selectValue(rval:uint,gval:uint,bval:uint,tol:uint){
		
		coltol = tol;
		Rcolval = rval;
		Gcolval = gval;
		Bcolval = bval;

		compareValues();
		
	}
	
	private function compareValues(){
						
			var test :int 
			var a : int = 0;
			var Rpos : uint = 1;
			var Gpos : uint = 2;
			var Bpos : uint = 3;
			var Apos : uint = 0;
			var count : uint = ImageArrayByte.length/4 
			Pixamount=0;
			
		for (a=0; a < count ;++a){
			
			Rpos = Rpos+4;
			Gpos = Gpos+4;
			Bpos = Bpos+4;
				
			//trace (ImageArrayByte.length);
			if (ImageArrayByte[Rpos] > (Rcolval-coltol) && ImageArrayByte[Rpos]<(Rcolval+coltol)
				&& ImageArrayByte[Gpos] > (Gcolval-coltol) && ImageArrayByte[Gpos]<(Gcolval+coltol)
				&& ImageArrayByte[Bpos] > (Bcolval-coltol) && ImageArrayByte[Bpos]<(Bcolval+coltol)){
			Pixamount = Pixamount+1
			var XYRpos:int=Rpos/4
			var Ypos:int = (Math.floor((XYRpos)/W)*1)/1;
			var Xpos:int = W-(((Math.ceil((XYRpos/W)*1)/1)*W)- XYRpos) ;
			markBmp(Xpos,Ypos);
			
			}
		}
	}
	
	private function markOutline(xpos:int,ypos:int){
		
		canvas.graphics.lineStyle(0,0x960000);
		canvas.graphics.drawRect(xpos,ypos,1,1)
		addChildAt(canvas,getChildIndex(OutputImage)+1);
	}
	
  	private function markBmp(xpos:int,ypos:int){
		markbmpData.lock();
		markbmpData.setPixel32(xpos,ypos,0x96ff0000)
		markbmpData.unlock();
		addChildAt(markbmp,getChildIndex(OutputImage)+1);
	}
	
	 public function Showmarked(){
		markbmp.bitmapData = markbmpData;
		//markbmp = new Bitmap(markbmpData);
		//addChildAt(markbmp,getChildIndex(OutputImage)+1);
	 }
	
	
	 public function clearMarkBmp(){
		markbmpData.dispose();
		markbmpData=new BitmapData(370,370,true,0x00000000)
	 }
	 
	 public function clearMark(){
		canvas.graphics.clear();
		removeChild(markbmp);
	 }
	 
	 
	 // Funrtion zur Rückgabe der Farbwerte eines Pixels in RGB
	 
	 public function returnValue(xk:uint,yk:uint):Array{
		var xkoord=xk;
		var ykoord=yk;
		var pixValue;
		var returnArray: Array = new Array();
		pixValue=OutputImage.bitmapData.getPixel(xkoord,ykoord);
		
		returnArray[0]=(pixValue & 0xff0000) >> 16;
		returnArray[1]=(pixValue & 0xff00) >> 8;
		returnArray[2]= pixValue & 0xff;
		trace (returnArray);
		return returnArray;
	 }
	 
	 public function destroy(){
	 }
	 
		
		
	}	//Class close
}	// Package close