﻿/*#############################################################
# 				GraphDraw									 ##
#														     ##
# Zur Repräsentation von errechneten Bildern		 .       ##
# !! Damit die Beschriftung funktioniert, muss eine Schriftart
# mit dem Klassennamen: Arial_type in die SWF eingebettet sein!!
#														     ##
#(c) 2008, Henryk Hodam 									 ##
#############################################################*/


package {
	
	import SatCalculator;
	import Display;
	import ImageCalc;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	
	public class GraphDraw extends Sprite {
	var CanvasAxes:Shape; 		// Container für Achsen Zeichnung
	var CanvasGraph:Shape; 		// Container für Graphen Zeichnung
	var DataArray_Y:Array;	// Array das die y-Werte enthält
	var DataArray_X:Array; 	// Array das die y-Werte enthält
	var Label_X:Array;		// Beschriftung der X-Achse
	var Label_Y:Array;		// Beschriftung der Y-Achse
	var XRange:Array;		// Zahlenbereich der X-Achse
	var YRange:Array;		// Zahlenbereich der Y-Achse
	var XLength:int;		// Länge der X_Achse in Pixeln
	var YLength:int;		// Länge der Y_Achse in Pixeln
	var XZero:Number;		// Stelle [0] für x-Nullpunkt Stelle [1] für y-Nullpunkt
	var YZero:Number;
	var ScaleFactorX:Number;
	var ScaleFactorY:Number;
	
	//var PictOut:ImageCalc;
	
	public function GraphDraw(...args){ // Argumente = (0:X-Werte:Array,1:Y-Werte:Array,2:X-Label:Array,3:Y-Label:Array,X-Länge:int,Y-Länge:int,Autoscale:Boolean,xMinimum:Number,yMinimum:Number);
	 
	if ( args[2] == 0 && args[3]== 0){
	 DataArray_X = translateArray(args[0]);
	 DataArray_Y = translateArray(args[1]);
	 Label_X = new Array();
	 Label_Y = new Array();
	 XRange = new Array(2);
	 YRange = new Array(2);
	 if (args[6]==true){
		 YRange[0]=args[7];
		 YRange[1]=args[8];
		 XRange = rangeSet(DataArray_X);
		 }
		else{
		 XRange = rangeSet(DataArray_X);
		 YRange = rangeSet(DataArray_Y);
		}
	 XLength = args[4];
	 YLength = args[5];
	 ScaleFactorX = XLength /(XRange[1]-XRange[0]);
	 ScaleFactorY = YLength /(YRange[1]-YRange[0]);
	 XZero = (returnZero(XRange[0]));
	 YZero = (returnZero(YRange[0]));
	 CanvasAxes = new Shape();
	 CanvasGraph = new Shape();
	 addChild(CanvasGraph);
	 trace ("XRange: "+XRange+" YRange: "+YRange+" XZero: "+XZero+" YZero: "+YZero)
	//filterData();	
	drawAxes ();
	drawGraph ();
	}
		
	else{
		trace ("mitLabel");
	 DataArray_X = translateArray(args[0]);
	 DataArray_Y = translateArray(args[1]);
	 Label_X = new Array();
	 Label_X = translateArray(args[2]);
	 Label_Y = new Array();
	 Label_Y = translateArray(args[3]);
	 XRange = new Array(2);
	 YRange = new Array(2);
	  if (args[6]==true){
		 YRange[0]=args[7];
		 YRange[1]=args[8];
		 XRange = rangeSet(DataArray_X);
		 }
		else{
		 XRange = rangeSet(DataArray_X);
		 YRange = rangeSet(DataArray_Y);
		}
	 
	 XLength = args[4];
	 YLength = args[5];
	 CanvasAxes = new Shape();
	 CanvasGraph = new Shape();
	 
	 XZero = returnZero(XRange[0])
	 YZero = returnZero(YRange[0])
	 
	 ScaleFactorX = XLength /(XRange[1]-XRange[0]);
	 ScaleFactorY = YLength /(YRange[1]-YRange[0]);
	 trace ("DataArray_X: "+DataArray_X);
 	 trace ("DataArray_Y: "+DataArray_Y);
	 trace ("DataArray_X: "+DataArray_X);
 	 trace ("Label_Y: "+Label_Y);
	 trace ("Label_X: "+Label_X);
	 addChild(CanvasGraph);
	
	//filterData();	
	drawAxes ();
	drawGraph ();
	labelAxis("X");
	labelAxis("Y");
	
	
	 trace ("XRange: "+XRange+" YRange: "+YRange+" XZero: "+XZero+" YZero: "+YZero)
		}
	}
	
	// Ermittelt den Werteumfang der übergebenen Arrays
	
	private function rangeSet(ar:Array):Array{
		var ReturnArray:Array = new Array(2);
		var min = ar[1];
		var max = ar[1];
		for (var f=0;f< ar.length;++f){
				if (ar[f]<min){
				min = ar[f];
				}
				else if  (ar[f]>max){
				max = ar[f];	
				}
				ReturnArray[0]=min;
				ReturnArray[1]=max;
				if (ReturnArray[0]>=0){
					ReturnArray[0]=0}
		}
		
		return ReturnArray;
	}
	
	private function drawAxes (){
		trace ("Drawing Axes");
		CanvasAxes.graphics.lineStyle(2,0xFFAA00);
		CanvasAxes.graphics.moveTo(0+XZero,0);
		CanvasAxes.graphics.lineTo(0+XZero,YLength+YZero*ScaleFactorY);
		CanvasAxes.graphics.moveTo(0,YLength);
		CanvasAxes.graphics.lineTo(XLength,YLength);
		addChild(CanvasAxes);
		
	}
	
	private function drawGraph(){
		trace ("XZero: "+XZero);
		trace ("ScaleFactorX: "+ScaleFactorX);
		removeChild(CanvasGraph);
		CanvasGraph.graphics.clear();
		CanvasGraph.graphics.lineStyle(1,0xFF0000);
		for (var a=0;a<DataArray_X.length-1;a++){
			trace (typeof(DataArray_Y[a])); 				
			CanvasGraph.graphics.lineStyle(1,0x00FF0000)
			CanvasGraph.graphics.moveTo(DataArray_X[a]*ScaleFactorX+XZero,YLength-DataArray_Y[a]*ScaleFactorY);
			CanvasGraph.graphics.lineTo(DataArray_X[a+1]*ScaleFactorX+XZero,YLength-DataArray_Y[a+1]*ScaleFactorY);
			addChild(CanvasGraph);
				
		}
	}
		
	//Datenarray wir nach ungültigen einträgen durchsucht und diese werden gelöscht	

		
		
			
			/*else if (DataArray_Y[a] is Object){
				trace ("enthält leer");
				a++;
				CanvasGraph.graphics.moveTo(DataArray_X[a]*ScaleFactorX+XZero,YLength-DataArray_Y[a]*ScaleFactorY);
				CanvasGraph.graphics.lineTo(DataArray_X[a+1]*ScaleFactorX+XZero,YLength-DataArray_Y[a+1]*ScaleFactorY);
				addChild(CanvasGraph);
			}*/
	
	
	
	private function returnZero(RangeMin:Number):Number{
	var ReturnInt:Number ;
		if (RangeMin<0){
			ReturnInt=(RangeMin)*-1;
		}
		else if (RangeMin>=0){
			ReturnInt =0;
		}
	return ReturnInt;
	
	}
	
	private function labelAxis(Axis:String){
		trace (Label_X.length);
		trace ("Labeling: "+Axis);
		
		
		if (Axis=="X"){
			for(var b=0; b<Label_X.length;b++){
				var Text:TextField = new TextField();
				var myFont:Font = new Arial_type();
				var format:TextFormat = new TextFormat();
				format.font = myFont.fontName  ;
				format.color = 0x000000;
				format.size = XLength*0.06;
				trace ("label "+Label_X);
				Text.textColor= 0x00;
				
				Text.text = Label_X[b].toString();
				
				Text.setTextFormat(format);
				Text.embedFonts=true;
				Text.selectable=false;
				Text.x=(DataArray_X[b]*ScaleFactorX+XZero)
				Text.y=YLength+YZero*ScaleFactorY;
				Text.rotation=60;
				addChild(Text);
			}
		}
		
		else if (Axis=="Y"){
			for(var b=0; b<Label_Y.length;b++){
				var Text:TextField = new TextField();
				var myFont:Font = new Arial_type();
				var format:TextFormat = new TextFormat();
				format.font = myFont.fontName;
				format.color = 0x0000FF;
				format.size = YLength*0.09;
				trace ("label"+Label_Y);
				Text.textColor= 0x00FF0000;
				
				// Damit der loop nicht anhält wenn Label_Y leere Stellen enthält
				
				Text.text = Label_Y[b].toString();			
				if (Text.text.length>4){
					Text.text = Text.text.slice(0,4);
				}
				
				Text.setTextFormat(format);
				Text.embedFonts=true;
				Text.selectable=false;
				Text.x= DataArray_X[b]*ScaleFactorX;
				Text.y=(YLength-DataArray_Y[b]*ScaleFactorY)-12;
				addChild(Text);
			}
		}
	}
	
	// überführt die eingehenden Arrays in die Arrays mit denen innerhalb der Klasse gearbeitet werden soll
	// so wird verhindert, dass die Originalen Arrays die von KlassenAufrufer übergeben wurden mglw. zurechtgekürzt werden
	// Gleichzeitug werden alle nicht besetzten Stellen im Array rausgeschmissen.
	
	function translateArray(InArray:Array):Array{
		var ReturnArray:Array = new Array();
		for (var i=0;i<InArray.length;i++){
			if (InArray[i] is Number || InArray[i] is int || InArray[i] is String){
			ReturnArray.push(InArray[i]);
			}
		}
		return ReturnArray;
	}
			
	}	//Class close
}	// Package close