﻿/*#############################################################
# 				ImageCalc 									 ##
#														     ##
#Führt Berechnungen mit zwei übergebenen Bitmaps aus.        ##
#															 ##
#														     ##
#(c) 2008, Henryk Hodam 									 ##
#############################################################*/


package {
	
	import Display;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	
	public class ImageCalc extends Display {
	// Bildmaße
	var xextend:int // Bildbreite
	var yextend:int // Bildhöhe
	var PixRect:Rectangle;// Bereich zum Einlesen des ByteArray
	
	// Variablen für eine einfache Bitmap to Array Umformung
	
	var singleArray:Array;
	
	// Variablen für Bild1
	var Img1:BitmapData;
	var Img1Array:Array;
	var Img1bmp:Bitmap;
	var Img1ByteArray:ByteArray;
	
	// Variablen für Bild2
	
	var Img2:BitmapData;
	var Img2bmp:Bitmap;
	var Img2Array:Array;
	var Img2ByteArray:ByteArray;
	
	// Variablen für Ergebnisbild
	
	var ImgResult:BitmapData;
	var ImgResultbmp:Bitmap;
	var ImgResultArray:Array;
	var NDVIResultArray:Array;
	var NDVIDataArray:Array;
	var SUBSTResultArray:Array;
	var SUBSTDataArray:Array;
	var ndvi:Number;
	var subst:Number;
	

	

	
//public function ImageCalc(Image1:Bitmap, Image2:Bitmap){
	
public function ImageCalc(...args){
 if (args.length>0){
	super(args[2],args[3]);	
	
	var datatype:String = args[0].toString();
	
	
	//trace("Zur Rechnung übergeben:" + datatype);
	switch(datatype){
		
		case "[object Bitmap]":
			
		xextend= args[0].width;
		yextend= args[1].height;
		w= args[0].width; 			// ändert die Bildmaße in Display
		h= args[1].height;			// ändert die Bildmaße in Display
		PixRect = new Rectangle(0,0,xextend,yextend);
		
		Img1bmp=args[0];
		Img2bmp=args[1];
		
		// Einlesen der Bildinformationen in ByteArrays (da mit Arrays gerechnet wird-notwendig?
		
		Img1ByteArray = new ByteArray();
		Img1ByteArray = Img1bmp.bitmapData.getPixels(PixRect);
		Img2ByteArray = new ByteArray();
		Img2ByteArray = Img2bmp.bitmapData.getPixels(PixRect);
		
		ImgResult = new BitmapData(xextend,yextend);
		Img1Array = new Array();
		Img2Array = new Array();
		
		NDVIResultArray = new Array();
		NDVIDataArray = new Array();
		SUBSTResultArray = new Array();
		SUBSTDataArray = new Array();
		
		
		transormToArray(Img1bmp,1);
		transormToArray(Img2bmp,2);
		
		break;
		default:
		 
		trace ("Calculating Array");
		xextend = args[2];
		yextend = args[3];
		
		PixRect = new Rectangle(0,0,xextend,yextend);		 
		
		Img1Array = new Array();
		Img1Array = args[0];
		Img2Array = new Array();
		Img2Array = args[1];
		trace ("Img1Array länge:"+ args[0].length)
		
		NDVIResultArray = new Array();
		NDVIDataArray = new Array();
		SUBSTResultArray = new Array();
		 
		}
 }
 else{};
		 
		
	}
	

		
	
	
	// ließt die Bilddaten aus den Bitmaps in ein Array ein, mit dem weitergerechnet werden kann
	
	private function transormToArray(sourceBmp:Bitmap,ImageNumber:int){
		
		var color:int;
		var	colorint:int;
		
		
		switch (ImageNumber){
		case 1:
			for (var xcounter=0; xcounter < xextend ; ++xcounter){
				for (var ycounter = 0; ycounter < yextend; ++ycounter){
				color = sourceBmp.bitmapData.getPixel(ycounter, xcounter);  
				colorint = color & 0xff
				Img1Array.push(colorint);
				
				}
			}
			

		break;
		case 2:
		
			for (var xcounter=0; xcounter < xextend ; ++xcounter){
				for (var ycounter = 0; ycounter < yextend; ++ycounter){
				color = sourceBmp.bitmapData.getPixel(ycounter, xcounter);  
				colorint = color & 0xff;
				Img2Array.push(colorint);
				
				}
			}
			
		break;
		default:
		throw new Error(" No valid option for Imgage Number. Valid Numbers 1,2")
		
		}
		
	}
	
public function BitmapToArray(sourceBmp:Bitmap):Array{
	trace("Transforming Bitmap to Array")
		singleArray= new Array();
		var color:int;
		var	colorint:int;
		xextend=sourceBmp.width;
		yextend=sourceBmp.height;
		
			for (var xcounter=0; xcounter < xextend ; ++xcounter){
				for (var ycounter = 0; ycounter < yextend; ++ycounter){
				color = sourceBmp.bitmapData.getPixel(ycounter, xcounter);  
				colorint = color & 0xff;
				singleArray.push(colorint);				
				}
			}
		return singleArray;
	}
			
	

	
	
	
// Funktion disp zeig abbhängig von der angegebenen Option eines der Beiden Rechenbilder oder das Ergebnisbild an
	
	public function disp(s:String){
		
		switch(s){
			case "ImageA":
				Show(Img1Array,"StretchArray")
				break;
			case "ImageB":
			 	Show(Img2Array,"StretchArray")
			 	break;
			case "Result":
			
				Show(NDVIResultArray,"StretchArray");
				
				break;
			
			case "Resultsubst":
			
				Show(SUBSTResultArray,"StretchArray");
				
				break;
			default:
				throw new Error(" No valid option for ImageCalc.disp method. Valid options are: ImageA, ImageB, Result")
		}
		
	}
	
	
	
	public function outSubst(A:Array,B:Array):Array{
		var ReArray:Array = new Array();
		for (var counter=0; counter < A.length ; ++counter){
			subst =  A[counter]-B[counter];
			if (subst<0){
				subst=subst*-1;
			}
			ReArray.push(subst);
			
		}
		trace ("ReArray40: "+ReArray[40])
		return ReArray;
	}
		
	
	// Die Funktionen für die ChangeDetection und den NDVI sind als privat und public deklariert. Aus irgendeinem Grund
	// können bei direktem Aufruf als public die errechneten Werte nicht als float(Number) in das Ergebnis Array geschrieben werden.
	
    
	
	public function substAB(){
		substABint()
	}	
	private function substABint(){
		
		for (var counter=0; counter < Img1Array.length ; ++counter){
			subst =  Img1Array[counter]-Img2Array[counter];
			if (subst<0){
				subst=subst*-1;
			}
			SUBSTResultArray.push(subst);
			SUBSTDataArray.push(subst);
		}
		trace("Beispiel aus SUBST: "+ Img1Array[50]+"+"+Img2Array[50]+"="+SUBSTResultArray[50])
	}
	
	public function NDVI(){
			NDVIint()
	}
	
	    private function NDVIint(){
			for (var counter=0; counter < Img1Array.length ; ++counter){
				ndvi =  (Img1Array[counter]-Img2Array[counter]) / (Img1Array[counter]+Img2Array[counter]);
				if (ndvi.toString() == "NaN"){
					//trace ("NDVI IS NaN");
					ndvi=0;
					ndvi = 0.01* Math.round(100*ndvi)
				}
				else{
				ndvi = 0.01* Math.round(100*ndvi);
				}
				NDVIResultArray.push(ndvi);
				NDVIDataArray.push(ndvi);
			
			}
			trace ("NDVI BEispielwert: " + NDVIResultArray[50]);
		}
	
	public function getNDVIArray():Array {
		return NDVIResultArray;
	}
	
	public function getNDVIDataArray():Array {
		return NDVIDataArray;
	}
	
	public function getSUBSTArray():Array {
		return SUBSTResultArray;
	}
	
	public function getSUBSTDataArray():Array {
		return SUBSTDataArray;
	}
	
	//public function getSUBSTDataArray():Array {
	//	return SUBSTResultArray;
	//}
	
	public function getPixValue(InArray:Array,W:int,Y:int,xpos:int,ypos:int):int{
		var ArrayPos:int = (ypos*500)+(xpos-500);
		trace ("arpos:" +ArrayPos);
		var ReturnValue:Number = ArrayPos;
		return ArrayPos;
	}
	
		
	
		
	}	//Class close
}	// Package close