﻿// ImageLoad zeigt Bilder an und ermöglicht verschiedene Modifikationen:
// ImageLoad - Die Main Class. Zeigt Bild. Benötigte Variablen: ImageLoad(Bitmap);
// ImageLoad.magnify - Vergrössert einen definierten Ausschnitt aus dem ImageLoad Objekt. Variablen (alle uint): ImageLoad.magnify (Zentraler punkt X, zentraler Punkt Y, Ausschnittsgrösse X, Ausschnittsgrösse Y, Zoomfaktor, Anzeigkoordinate x, Anzeigkoordinate y)


package {
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.text.*;
	
	
	
	public class ImageLoad extends Sprite {
		
		var w:uint // Breite des Bildes
		var h:uint // Breite des Bildes
		var OutputImage:Bitmap;//auszugebendes Bild
		var ImageSet:BitmapData;// 
		var ImageCorrected:Bitmap;//korrigiertes Bild
		var ImageArray:Array; // Array für Bildbearbeitung
		var ImageArrayint:Array; // Array für Histogramm
		var ImageArrayByte:ByteArray;
		var color:uint; //Einzulesender Farbwert
		var color2:uint; // Einzulesender Farbwert für Korrektur
		var colorint:uint;// in integer umgewandelter Farbwert
		var countArray:Array;// Das Array in welches die Häufigkeiten fürs Histogramm geschrieben werden
		
		//VAriablen für Histogram
		var Anzahl:TextField;
		var Wertemax:TextField;
		var Wertemin:TextField;
		var countMax:TextField;
		var canvas:Shape; // Container für Histogramm-Zeichnung
		var xHist:uint; // x-Position des Histogramms
		var yHist:uint; // y-Position des Histogramms
		var maxC:uint; // Maximalwert des Countarrays
		
		// Variablen für Magnify
		var xzoom:uint // Position des Zoommittelpunkts x
		var yzoom:uint// Position des Zoommittelpunkts y
		var xzoomarea:uint// Abmessung des Zoombereichs x
		var yzoomarea:uint// Abmessung des Zoombereichs y
		var zoomfactor:uint//Vergrösserung
		var xzoompos:uint //  x Position der Zoomausgabe
		var yzoompos:uint //  y Position der Zoomausgabe
		var magniV: BitmapData;// Dateninhalt des Zoombereichs
		var magni: ByteArray;// Dateninhalt des Zoombereichs
		var magniout: Bitmap;// Ausgabeinhalt des Zoombereichs
		var rectsource:Rectangle; // Definierter Berceich des Zooms
		var rectdest:Rectangle; // Definierter SchreibBerceich des Zooms
		
		// Variablen für Marker
		var xmark:uint//xPosition der Markers
		var ymark:uint//yPosition der Markers
		var markercol:uint//Farbe des Markers
		var canvasmarker:Shape;//Zeichenfläche für Marker
		var canvasIndicator:Boolean
		
		var mw:uint; // Mittelwert
		var total:int; // aufaddierte Werte
		var min:uint;//Minimum des Tonwertumfangs
		var max:uint;//Maximum des Tonwertumfangs
		var steig:Number ;
		var yachs:Number;
		
		// Variablen für changePixel
		
		var pixPosX:uint; //X Position des Pixels
		var pixPosY:uint; //Y Position des Pixels
		var pixCol:uint;  // Wert des Pixels
		var ArrayPos:uint;// ArrayPosition des zu ändernden Pixels
		var ImagePxArray:uint;// Array für Ausgabebild
		var ImagePxChange:BitmapData;//Ausgabebild 
		var PixRect:Rectangle;
		var PixelImage:Bitmap;
		
		// Variablen für getSumValue
		
			
		// Variablen für getPixValue
		
		var xkoord:uint;
		var ykoord:uint;
		var pixValue:uint;
		
		
		public function ImageLoad (Image:Bitmap){
			canvas=new Shape();
			this.addChild(canvas);
			OutputImage = Image;
			addChild(OutputImage); 
			
		}
		
		
		public function Histogram(xH:uint,yH:uint){
			canvas=new Shape();
			addChildAt(canvas,getChildIndex(OutputImage)+1);
			xHist=xH;
			yHist=yH;
			ImageArray = new Array (); 
			ImageArrayint = new Array ();
			countArray=new Array();
			readValues();
			MinMax()
			HistogramData();
			MinMax()
			HistogrammDraw();
			
		}
		
		private function readValues(){
			
			var a : int = 0;
			var b : int = 0;
						
			for (a=0; a < 500 ; ++a){
				for (b = 0; b < 500; ++b){
					
				color = OutputImage.bitmapData.getPixel(a, b);
				colorint = ((color & 0xff0000) >> 16)^((color & 0xff00) >> 8)^(color & 0xff);
				ImageArray.push(color);
				ImageArrayint.push(colorint);
						
				}
			}
			
			
		}//readValues close
		
		private function HistogramData (){ // erzeugt ein Array mit Häufigkeitsverteilung für das Bild
			for (var k=0; k<256; k++) {
			countArray.push(0);
				}
			
		var i : int = -1;
		//var n : uint = 0;

				while( ++i < ImageArrayint.length ){
   					var a = ImageArrayint[i];
  					countArray[a]=(countArray[ a ] + 1)
   				}
		//trace( countArray );
		trace ("Array Länge: "+ImageArray.length);
		trace ("CountArray Länge: "+countArray.length);
		
		maxC = 0;
		
		for (h=0;h<countArray.length;++h){
				if (countArray[h]>maxC){
				maxC = countArray[h];				
				}
			}
			trace ("maxC="+maxC);
		
		
	}//HistogramData close
	
	
	private function HistogrammDraw(){
		
		countMax = new TextField();
		Wertemax = new TextField();
		Wertemin = new TextField();
		countMax.text="";
		
		Wertemax.text="";
		Wertemin.text="";
		
		canvas.graphics.clear();
		countMax.text=maxC.toString();
		countMax.textColor= 0xffffff;
		countMax.x = xHist;
		countMax.y = yHist-(maxC/60)-13;
		//countMax.embedFonts = true;
		//countMax.rotation = +45;
		addChildAt(countMax,getChildIndex(OutputImage)+1);
		Wertemax.text=max.toString();
		Wertemax.x = xHist+max;
		Wertemax.y = yHist-13;
		Wertemax.textColor = 0xffffff
		addChildAt(Wertemax,getChildIndex(OutputImage)+1);
		Wertemin.text=min.toString();
		Wertemin.x = xHist+min;
		Wertemin.y = yHist-13;
		Wertemin.textColor = 0xffffff
		addChildAt(Wertemin,getChildIndex(OutputImage)+1);
		//Wertemax = new TextField();
		//Wertemin = new TextField();
		var j : int = -1;
			while( ++j < countArray.length ){
				if (countArray[j] is int){
				canvas.graphics.lineStyle(2,0xff);
				canvas.graphics.moveTo(j+xHist,yHist);
				canvas.graphics.lineTo(j+xHist,(yHist-(countArray[j])/60));
				canvas.graphics.lineStyle(1,0xffffff);
				canvas.graphics.moveTo(xHist,yHist+2);
				canvas.graphics.lineTo(xHist,(yHist-(countArray[j])/60)+2);
				canvas.graphics.moveTo(xHist,yHist+2);
				canvas.graphics.lineTo(xHist+255,yHist+2);
			}
			
		}
		addChildAt(canvas,getChildIndex(OutputImage)+1);
		trace (countArray);
						
	} //HistogrammDraw close
	
	
	
	public function stretch(minZ:uint,maxZ:uint){
		ImageArray = new Array (); 
		ImageArrayint = new Array ();
		countArray=new Array();
		var steigA:Number 
		var yachsA:Number
		var maxZiel = maxZ;
		var minZiel = minZ;
		readValues();
		MinMax();
		ContStrech(minZiel,maxZiel);
		readValues();
	}
		
	// Funktion zur linearen Kontrastkorrektur

	
	
	
	private function MinMax(){
		
		var f: int=0;
		var h: int=0;
		max=ImageArrayint[0]
		min=ImageArrayint[0]
		
			for (h=0;h<ImageArrayint.length;++h){
				if (ImageArrayint[h]>max){
				max = ImageArrayint[h];				
				}
			}
		
		
			for (f=0;f<ImageArrayint.length;++f){
				if (ImageArrayint[f]<min){
				min = ImageArrayint[f];				
				}
		}
	
		trace ("Maximum:"+max);
		trace ("Minimum:"+min);
		
	}
	
	private function ContStrech(mi:uint,ma:uint){
		var maxi = ma;
		var mini = mi;
		steig = ((maxi-mini)/(max-min));
		yachs = (mini - (steig*min));
		var c:int=0;
		var d:int=0;
		var Kont:int;
		ImageSet = new BitmapData(500,500,false)
			for (c=0; c< 500 ; ++c){
				for (d= 0; d < 500; ++d){
					color2 = OutputImage.bitmapData.getPixel(c, d);
					var R = Math.round((steig*((color2 & 0xff0000) >> 16))+yachs);
					
					var G = Math.round((steig*((color2 & 0xff00) >> 8)) +yachs);
					
					var B = Math.round((steig*(color2 & 0xff))+yachs);
			
					var Kont = (R << 16 ^ G << 8 ^ B);
					ImageSet.setPixel (c,d,Kont);
				}
				
			}
					
		//trace (ImageArrayint)
		trace("f(x)="+steig+"x"+yachs);
		ImageCorrected = new Bitmap(ImageSet);
		OutputImage = ImageCorrected;
		addChild(OutputImage);
		
		
	}
			
	
	private function Mittelwert(){
		
		var total:uint;
		var mw:uint;
		var f:uint = 0;
		var g: int = 255;
		while (++f<ImageArray.length){
			total = total+ImageArray[f]
		}
		
		mw = total/(ImageArray.length)
		trace ("Addiert: "+total);
		trace ("Mittelwert: "+mw);
		//trace (ImageArray);
		
	
		concorrect();
		
	}
		
	private function concorrect(){
		var c:int=0;
		 var d:int=0;
		 var Kont:int;
			ImageSet = new BitmapData(500,500,false)
			for (c=0; c< 500 ; ++c){
				for (d= 0; d < 500; ++d){
					color2 = OutputImage.bitmapData.getPixel(c, d);
					//contrast * (p0 - avg) + avg
					var R = 1.1*((((color2 & 0xff0000) >> 16))-mw)+mw;
					if (R>255){R=255};
					var G = 1.1*(((color2 & 0xff00)-mw)+mw >> 8);
					if (G>255){G=255};
					var B = 1.1*((color2 & 0xff)-mw)+mw;
					if (B>255){B=255};
					var Kont = (R << 16 ^ G << 8 ^ B);
					//trace (R);
					//trace (Kont);
					//colorcorr = ((color2 & 0xff0000) >> 16)+((color2 & 0xff00) >> 8)+(color2 & 0xff);
					ImageSet.setPixel (c,d,Kont);
					
				}
			}
			
			trace ("Rot = "+R+"Grün = "+G+"Blau = " +B);
			ImageCorrected = new Bitmap(ImageSet);
			OutputImage = ImageCorrected;
			addChildAt(OutputImage,0);
			
			
		
	}// Contrast close
	
	 public function clearHist(){
		
		canvas.graphics.clear();
		
	 }

	 // Zoomfunktion
	 
	 public function magnify(xz:uint,yz:uint,xa:uint,ya:uint,fact:uint,xpos:uint,ypos:uint){
		 w = OutputImage.width ;
		 h = OutputImage.height;
		 xzoom = xz ; // Abmessung des Zoombereichs x
		 yzoom = yz ; // Abmessung des Zoombereichs y
		 xzoomarea = xa;
	     yzoomarea = ya;
		 zoomfactor = fact;
		 xzoompos = xpos;
		 yzoompos = ypos;
		 
		 
		magnifier ();
		
		 
	 }
	 
	 private function magnifier(){
		 var xupleft:int = xzoom-(xzoomarea/2);
		 var yupleft:int = yzoom-(yzoomarea/2);
		 var xlowright:int = xzoom+(xzoomarea/2)
		 var ylowright:int = yzoom+(yzoomarea/2);
		 rectsource = new Rectangle (xupleft,yupleft,xzoomarea,yzoomarea);
		 if (xupleft < 0 && yupleft < 0 && xlowright <= h){
			 trace ("if")
			  rectdest = new Rectangle ((xupleft*-1),(yupleft*-1),xzoomarea,yzoomarea);
		 }
		  else if (xupleft >= 0 && yupleft < 0 && xlowright < h){
			  trace ("else1")
			  rectdest = new Rectangle (0,(yupleft*-1),xzoomarea,yzoomarea);
		 } 
		 
		   else if (xupleft < 0 && yupleft >= 0 && ylowright < h ){
			   trace ("else2")
			  rectdest = new Rectangle ((xupleft*-1),0,xzoomarea,yzoomarea);
		 }
		 
		   else if (xlowright > w && yupleft < w &&  yupleft >0 ){
			   trace ("else3")
			  rectdest = new Rectangle (0,0,xzoomarea-(xlowright-w),yzoomarea-(ylowright-w));
		 }
		 
		   else if (xlowright > w && yupleft >=0){
			   trace ("else4")
			  rectdest = new Rectangle (0,0,xzoomarea-(xlowright-w),yzoomarea);
		 }
		 
		   else if (xupleft >= 0 && yupleft < 0 && xlowright > w){
			   trace ("else5")
			  rectdest = new Rectangle (0,(yupleft*-1),xzoomarea-(xlowright-w),yzoomarea-(yupleft*-1));
		 }
		 
		   else if (ylowright >= h && xupleft < 0  ){
			   trace ("else6")
			  rectdest = new Rectangle ((xupleft*-1),0,xzoomarea-(xupleft-w),yzoomarea-(ylowright-h));
		 }
		 
		    else if (ylowright >= h && xupleft < w  ){
			   trace ("else7")
			  rectdest = new Rectangle (0,0,xzoomarea,yzoomarea-(ylowright-h));
		 }
		
		 
		   else {
			   trace ("else")
		 rectdest = new Rectangle (0,0,xzoomarea,yzoomarea);
		}
		trace (xupleft);
		trace (yupleft);
		trace (xlowright);
		trace (ylowright);
		trace (rectdest);
		// trace(rectsource);
		 magni = new ByteArray;
		 magniV = new BitmapData (xzoomarea,yzoomarea);
		 magni = OutputImage.bitmapData.getPixels(rectsource)
		 magni.position=0;
		 magniV.setPixels(rectdest,magni);
		 magniout= new Bitmap (magniV);
		 magniout.x = xzoompos;
		 magniout.y = yzoompos;
		 magniout.scaleX = zoomfactor;
		 magniout.scaleY = zoomfactor;
		 //trace (magni);
		 addChild(magniout);
		 
	 }
	 
	 // Funktion zum Setzen eines Bildmarkers
	 
	public function setMarker (xm:uint, ym:uint,col:uint) {
		  xmark=xm;
		  ymark=ym;
		  markercol=col;
		  canvasmarker = new Shape;
		  //addChild(canvasmarker);
		  marker();
		  addChildAt(canvasmarker,getChildIndex(OutputImage)+1);
	  }
	 	private function marker(){
			canvasmarker.graphics.clear();
			canvasmarker.graphics.lineStyle(0.5,markercol);
			canvasmarker.graphics.moveTo(xmark-10,ymark);
			canvasmarker.graphics.lineTo(xmark+10,ymark);
			canvasmarker.graphics.moveTo(xmark,ymark-10);
			canvasmarker.graphics.lineTo(xmark,ymark+10);
		}
		
	public function clearMarker(){
		
		canvasmarker.graphics.clear();
		removeChildAt(getChildIndex(canvasmarker));
		trace("Marker cleared");
	 }
			
	// Funktion zur Änderung eines bestimmten Pixels 
	
	  public function changePixel (pxX:uint, pxY:uint,pxCol:uint){
		
		ImageArray = new Array; 
		ImageArrayint = new Array;
		pixPosX = pxX; //X Position des Pixels
		pixPosY = pxY; //Y Position des Pixels
		pixCol =  pxCol;
		w = OutputImage.width
		h = OutputImage.height
		PixRect = new Rectangle(0,0,w,h)
		ArrayPos = (((pixPosY*w)+(pixPosX-w))*4)-3;// Rechnet die Bildkoordinaten in eine Position im Bytearray um
		ImageArrayByte = new ByteArray;
		ImagePxChange = new BitmapData (w,h);
		ImageArrayByte = OutputImage.bitmapData.getPixels(PixRect)
		setPixel ();
	  }
	  
	//  private function normalize4bit (){
	//	   for (o < ImageArrayByte.length)
	//	   ImageArraByte[o]=ImageArraByte[o]*1
	  
		private function setPixel (){
			
			var Pixel:uint;
			var Pixelnew:uint;
			Pixelnew =((pixCol & 0xff0000) >> 16)^((pixCol & 0xff00) >> 8)^(pixCol & 0xff);
			trace ("ArrayPos="+ArrayPos);
			trace ("Pixelfarbe="+Pixelnew);
			trace ("ArrayLänge="+ImageArrayByte.length);
			Pixel = OutputImage.bitmapData.getPixel(pixPosX,pixPosY)
			Pixel= ((Pixel & 0xff0000) >> 16)^((Pixel & 0xff00) >> 8)^(Pixel & 0xff)
			trace ("originalPixelfarbe="+Pixel);
			ImageArrayByte[ArrayPos]=pixCol & 0x0000ff;
			ImageArrayByte[ArrayPos+1]=pixCol  & 0x00ff;
			ImageArrayByte[ArrayPos+2]=pixCol & 0xff;
			ImageArrayByte.position=0;
		 	ImagePxChange.setPixels(PixRect,ImageArrayByte);
			//ImagePxChange.setPixel(pixPosX,pixPosY,pixCol);
			PixelImage = new Bitmap(ImagePxChange);
			OutputImage  = PixelImage;
			
			addChild(OutputImage);
			
		}

		
	public function resetImage(Image:Bitmap) {
		OutputImage=Image;
		addChild(OutputImage);
		
	}
	
	
	public function getPixValue (Image:Bitmap,xk:uint,yk:uint):uint {
		xkoord=xk;
		ykoord=yk;
		pixValue=OutputImage.bitmapData.getPixel(xkoord,ykoord);
		pixValue=((pixValue & 0xff0000) >> 16)^((pixValue & 0xff00) >> 8)^(pixValue & 0xff)
		return pixValue;
	}
		
		
	public function getSumValue(Image:Bitmap):uint{
		
		w = OutputImage.width
		h = OutputImage.height
		var k:uint;
		var hh:uint;
		var val:uint;
		var valsum:uint;
			
		for (k=0; k < w ; ++k){
				for (hh = 0; hh < h ; ++hh){
					val=OutputImage.bitmapData.getPixel(k,hh)
					valsum=valsum+val
				}
		}
		
		return valsum;
		}
	
	
	public function getMax():uint{
		var f: int=0;
		var h: int=0;
		
		min=ImageArrayint[0]
		
			for (h=0;h<ImageArrayint.length;++h){
				if (ImageArrayint[h]>max){
				max = ImageArrayint[h];				
				}
			}
				return max;
	}
		
	public function getMin():uint{
		var f: int=0;
		var h: int=0;
		
		min=ImageArrayint[0]
		
			for (f=0;f<ImageArrayint.length;++f){
				if (ImageArrayint[f]<min){
				min = ImageArrayint[f];		
							
				}
			}
			return min;
		}
		
		 
			
	}	//Class close
}	//Package close