﻿package com.utilities {
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.net.*;
	import FISEvents;
	
	public class ImageMeta extends Sprite {
		
		private var InitDataURL:String;
		private var InitDataRequest:URLRequest;	// Request zum Laden externer Variablen
		private var InitDataLoader:URLLoader;	// Loader zum Laden externer Variablen
		private var InitData:URLVariables;	
		
		private var MetaDataURL:String;
		private var MetaDataRequest:URLRequest;	// Request zum Laden externer Variablen
		private var MetaDataLoader:URLLoader;	// Loader zum Laden externer Variablen
		private var MetaData:URLVariables;		// enthält die externern Variablen
		public  var NumberofImages:int;
		public  var MetaDataArray:Array;		// Mehdimensionales Array, dass Alle Metadaten aufnimmt 
		private var MetaDataRow:Array
		private var MetaDataPaths:Array
		public  var MainName:String;			// Hauptbestandteil des dateinamens der Bilder
		public  var ImageURLs:Array;			// enthält die URLS der zu ldanenden Bilder
		public  var ImageTypes:Array;			// enthält die typen der Bilder RGB/channel
		private var RowsCreated:int;			// Wie viele Reihen wurden erstellt
		
		public function ImageMeta(url:String){
			RowsCreated = 0;
			InitDataURL = url;
			InitDataRequest = new URLRequest(InitDataURL);
			InitDataLoader = new URLLoader();
			InitDataLoader.load(InitDataRequest);
			InitDataLoader.addEventListener(Event.COMPLETE, readExternalData);
			
		} // Constructor close
		
		
		private function readExternalData(e:Event){
    		//var InitVariable:URLVariables = new URLVariables(InitDataLoader.data);
			InitData = new URLVariables(InitDataLoader.data);
			NumberofImages = InitData.ImageCount;
			MainName = InitData.Name;
			
			trace ("Number of Images: " + NumberofImages);
			trace ("Name of DataFiles: " + MainName);
			MetaDataArray= new Array(NumberofImages);
			ImageURLs = new Array();
			ImageTypes = new Array();
			layoutMetaFigure(NumberofImages);
			
		}
		
		//Legt die Tabelle für die Metadaten an
		
		private function layoutMetaFigure(num:int){
			
			MetaDataPaths = new Array();
			for (var i= 1; i<=num; i++){
			var MetaURL:String = "Images/"+MainName+"_"+i+".fis";
			MetaDataPaths.push(MetaURL);
			}
			trace (MetaDataPaths);
			getMetaData(0)
		}
		private function getMetaData(readAt:int){
			MetaDataRow = new Array();
			MetaDataLoader = new URLLoader();
			MetaDataURL=MetaDataPaths[readAt];
			MetaDataRequest = new URLRequest(MetaDataURL);
			MetaDataLoader.load(MetaDataRequest);
			trace ("reading AT "+ MetaDataPaths[readAt]);
			MetaDataLoader.addEventListener(Event.COMPLETE, readMetaData,false, 0, true);
		}
		
		private function readMetaData(e:Event){
			trace ("creating row "+RowsCreated);
			//var MetaVariable:URLVariables = new URLVariables(MetaDataLoader.data);
			MetaData = new URLVariables(MetaDataLoader.data);
			var Nummer:int = MetaData.Count;
			var Name_:String = MetaData.Name;
			var Datum:String = MetaData.Date_;
			var Typ:String = MetaData.Type;
			var Res_:int = MetaData.Res;
			var Unit_:String = MetaData.Unit;
			
			MetaDataRow[0] = Nummer;
			MetaDataRow[1] = Name_;
			MetaDataRow[2] = Datum;
			MetaDataRow[3] = Typ;
			MetaDataRow[4] = Res_;
			MetaDataRow[5] = Unit_;
			
			MetaData.Count = 20;
			
			var newURL:String = "Images/"+Name_;
			ImageURLs.push(newURL);
			ImageTypes.push(Typ);
			
			MetaDataArray[RowsCreated] = MetaDataRow;
			RowsCreated++; 
			//MetaDataLoader.removeEventListener(Event.COMPLETE, readMetaData)
			if (NumberofImages>RowsCreated){
				
				getMetaData(RowsCreated);
			}
			else{
				trace (MetaDataArray);
				trace (ImageURLs);
				trace (ImageTypes);
				
				dispatchEvent(new FISEvents(FISEvents.DATA_READY));
			}
			
		}

		
		
	}//public class close
} // package close