﻿
// Zum Auslesen von XML Formatierten MetaInformationen zu Bildaten in SatCalculator

package com.utilities {
	
	//import.flash.XML.*;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.net.*;
	import FISEvents;
	
	public class ImageMetaXML extends Sprite {
		
		private var InitDataURL:String;
		private var InitDataRequest:URLRequest;	// Request zum Laden externer Variablen
		private var InitDataLoader:URLLoader;	// Loader zum Laden externer Variablen
		//private var InitData:URLVariables;	
		private var XMLData:XML;				// enthält die eingelesenen Metadaten
		private var XMLDataClass:XML;				// enthält die eingelesenen Metadaten
		private var ClassDataURL:String;
		private var ClassDataRequest:URLRequest;	// Request zum Laden externer Klassen Variablen
		private var ClassDataLoader:URLLoader;	// Loader zum Laden externer Klassen Variablen
		
		
		public  var NumberofClasses:int;
		public  var NumberofImages:int;
		public  var MetaDataArray:Array;		// Mehdimensionales Array, dass Alle Metadaten aufnimmt 
		private var MetaDataRow:Array
		public  var ImageURLs:Array;			// enthält die URLS der zu ldanenden Bilder
		public  var ImageTypes:Array;			// enthält die typen der Bilder RGB/channel
		public  var ImageChannels:Array;		// Enthält die Agaben zum Kanal des Bildes
		public  var ImageClasses:Array;		// Enthält die Agaben zum Kanal eines Bildes
		public  var ImageClassesArray:Array;	// Enthält die Agaben zu Klassen Aller Klassifizierter Bilder
		public  var ImageExtends:Array;		// Enthält die Agaben Abmessungen des Bildes
		private var RowsCreated:int;			// Wie viele Reihen wurden erstellt
		private var ClassesAt:int;				// Wenn ein Klassifiziertes Bils eingelesen wird steht hier an welcher Stelle im Array es ist	
		private var Version:String;
		private var ClassBase:ClassifierBase;			// für eventl. Umrechnungen 
		
		public function ImageMetaXML(url:String){
			Version = "V 0.1 20110531";
			trace ("ImageMetaXML: "+Version);
			ClassBase = new ClassifierBase();
			RowsCreated = 0;
			InitDataURL = url;
			InitDataRequest = new URLRequest(InitDataURL);
			InitDataLoader = new URLLoader();
			InitDataLoader.load(InitDataRequest);
			InitDataLoader.addEventListener(Event.COMPLETE, readExternalData);
			
		} // Constructor close
		
		
		private function readExternalData(e:Event){
    		
			XMLData = new XML(e.target.data);
			trace (XMLData.IMAGES.IMAGE.length());
			ImageClassesArray = new Array();
			ImageTypes = new Array();
			ImageURLs = new Array();
			ImageChannels = new Array();
			NumberofImages=XMLData.IMAGE.length();
			MetaDataArray= new Array(NumberofImages);
			trace(XMLData.IMAGE[0].Name);
			getMetaData();
			//getMetaData(0);
		}
		
		
		//Legt die Tabelle für die Metadaten an

		private function getMetaData(){
			for (var i = 0; i < NumberofImages; i++){
			
			MetaDataRow = new Array();
			
			var Nummer:int =XMLData.IMAGE[i].Count;
			var Name_:String = XMLData.IMAGE[i].Name;
			var Datum:String = XMLData.IMAGE[i].Date_;
			var Typ:String = XMLData.IMAGE[i].Type;
			var Res_:int = XMLData.IMAGE[i].Res;
			var Unit_:String = XMLData.IMAGE[i].Unit;
			var Channel:String = XMLData.IMAGE[i].Channel;
			var File:String = XMLData.IMAGE[i].File;
			var MetaFile:String = XMLData.IMAGE[i].ClassFile;
			var StretchFactors:Array = new Array(XMLData.IMAGE[i].MinStretch,XMLData.IMAGE[i].MaxStretch);
			var LinearConv:Array = ClassBase.returnLinearFunction([Number(XMLData.IMAGE[i].ImageMin),Number(XMLData.IMAGE[i].ValueMin),Number(XMLData.IMAGE[i].ImageMax),Number(XMLData.IMAGE[i].ValueMax)]); // im array werden[Steigung,yAchsenabschnitt] gespeichert
			var ConVUnit:String = XMLData.IMAGE[i].ValueUnit;
			
			
			MetaDataRow[0] = Nummer;
			MetaDataRow[1] = Name_;
			MetaDataRow[2] = Datum;
			MetaDataRow[3] = Typ;
			MetaDataRow[4] = Res_;
			MetaDataRow[5] = Unit_;
			MetaDataRow[6] = Channel;
			MetaDataRow[7] = MetaFile;
			MetaDataRow[8] = [0,0];
			if (LinearConv){MetaDataRow[9]=LinearConv
							MetaDataRow[10]=ConVUnit};
			
			if (StretchFactors){MetaDataRow[11]=StretchFactors};
			
			
			MetaDataArray[i] = MetaDataRow;
			
			var newURL:String = "Images/"+File;
			ImageURLs.push(newURL);
			ImageTypes.push(Typ);
			ImageChannels.push(Channel);
			
			
			if (MetaFile){
			var ClassURL:String = "Images/"+MetaFile;
			ClassesAt = i
			initClassArray(ClassURL);
			}
			
			
			
			RowsCreated++; 
			
				if (NumberofImages==RowsCreated){
					trace (MetaDataArray);
					dispatchEvent(new FISEvents(FISEvents.DATA_READY));
					//getMetaData(RowsCreated);
				}
			}
			
		}
		
		private function initClassArray(urlin:String){
			ClassDataURL = urlin;
			trace ("Lade Klassen von :" + urlin);
			ClassDataRequest = new URLRequest(ClassDataURL);
			ClassDataLoader = new URLLoader();
			ClassDataLoader.load(ClassDataRequest);
			ClassDataLoader.addEventListener(Event.COMPLETE, builtClassArray);
		}
		
		private function builtClassArray(e:Event){
			XMLDataClass = new XML(e.target.data);
			trace ("KlassenAnzahl:" + XMLDataClass.CLASS.length());
			//NumberofClasses=XMLDataClass.CLASS.length();
			ImageClasses = new Array();
			for (var i = 0; i<XMLDataClass.CLASS.length(); i++){
				var pushArray = new Array();
				
				trace ("LESE:" + XMLDataClass.CLASS[i].Name); 
				var Name_:String = XMLDataClass.CLASS[i].Name;
				var R:int = XMLDataClass.CLASS[i].Val_R;
				var G:int = XMLDataClass.CLASS[i].Val_G;
				var B:int = XMLDataClass.CLASS[i].Val_B;
				
				pushArray[0] = Name_;
				pushArray[1] = R;
				pushArray[2] = G;
				pushArray[3] = B;
				ImageClasses[i] = pushArray;
			}
			ImageClassesArray[ClassesAt] = ImageClasses;
			trace (ImageClassesArray);
		}
				
		
	}//public class close
} // package close