﻿// ImageSwiper überlagert 2 Bilder welche bei Mausover per swipe miteinander verglichen werden können
// Benötigt 2 Bitmap Daten gleicher Grösse, wobei das das erste das zweite überlagert.

package com.utilities{
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.*;
	import flash.display.Bitmap;
	import flash.display.BitmapData;	
	import flash.ui.Mouse;
	
	public class ImageSwiper extends Sprite {
		
		public var FrontImage:Bitmap;     // Das vordere Bild
		public var FrontImage_BD:BitmapData; 
		
		public var BackImage:Bitmap; 	// Das hintere Bild
		public var BackImage_BD:BitmapData;
		
		public var FrontImageCopy_BD:BitmapData;
		public var FrontImageCopy:Bitmap;
		private var AlphaMask:BitmapData;
		private var NoAlphaMask:BitmapData;
		private var alphaRectangle:Rectangle; // Definiert den bereich an dem das vordere Bild transparent ist.
		private var NoAlphaRectangle:Rectangle; // Definiert den bereich an dem das vordere Bild nicht transparent ist.
		
		private var SwiperBut:Shape;		// Die Swiper Knopf Grafik
		private var SwiperBut_mc:MovieClip;	// mc für die swiper Grafik
		public var  SwiperColor:Number; // Farbe der Lupe
		public var 	SwiperScale:Number;
		
		
		public function ImageSwiper(im_a:Bitmap,im_b:Bitmap){
			FrontImage = im_a;
			BackImage = im_b;
			FrontImageCopy_BD =  new BitmapData(FrontImage.width,FrontImage.height);
			FrontImageCopy_BD.copyPixels(FrontImage.bitmapData,new Rectangle(0,0,FrontImage.width,FrontImage.height),new Point(0,0));
			FrontImageCopy = new Bitmap(FrontImageCopy_BD);
			NoAlphaMask = new BitmapData(FrontImage.width,FrontImage.height,true,0xffffffff);
			AlphaMask = new BitmapData(FrontImage.width,FrontImage.height,true,0x00ffffff);
			addChild(BackImage);
			
			addChild(FrontImageCopy);
			
			SwiperColor = 0xFF1020;
			SwiperScale = 1;
			SwiperBut_mc = new MovieClip();
			addChild(SwiperBut_mc);
			drawSwiper();
			
			this.addEventListener(MouseEvent.MOUSE_OVER,hideMouse);
			this.addEventListener(MouseEvent.MOUSE_OUT,showMouse);
			addEventListener(MouseEvent.MOUSE_MOVE,swipe)
		}// constructor close
		
			private function swipe(e:MouseEvent){
				// Mouse.hide();
				
				 var xmouse:int = mouseX; // da mouseX direkt keine ganzen Zahlen zurückgibt würde es sonst im Vollbildmodus Probleme geben
				 var ymouse:int = mouseY;
				 SwiperBut_mc.x=mouseX-SwiperBut_mc.width/2;
				 SwiperBut_mc.y=mouseY;
				 NoAlphaRectangle = new Rectangle (xmouse,0,FrontImage.width,FrontImage.height);
				 alphaRectangle = new Rectangle (0,0,xmouse,FrontImage.height);
				 FrontImageCopy.bitmapData.copyChannel(AlphaMask,alphaRectangle,new Point(0,0),BitmapDataChannel.ALPHA,BitmapDataChannel.ALPHA);
				 FrontImageCopy.bitmapData.copyPixels(FrontImage.bitmapData,NoAlphaRectangle,new Point(xmouse,0));
			}
			
			public function drawSwiper(){
				SwiperBut = new Shape();
				
				//LinkerPfeil
				 SwiperBut.graphics.beginFill(SwiperColor,1);
				 SwiperBut.graphics.lineStyle(1,SwiperColor);
				 SwiperBut.graphics.moveTo(0,7.5);
				 SwiperBut.graphics.lineTo(10,0);
				 SwiperBut.graphics.lineTo(10,5);
				 SwiperBut.graphics.lineTo(20,5);
				 SwiperBut.graphics.lineTo(20,10);
				 SwiperBut.graphics.lineTo(10,10);
				 SwiperBut.graphics.lineTo(10,15);
				 SwiperBut.graphics.lineTo(0,7.5);
				 SwiperBut.graphics.endFill();
				 
				//Kreis
				 SwiperBut.graphics.beginFill(SwiperColor,1);
				 SwiperBut.graphics.lineStyle(1,SwiperColor);
				 SwiperBut.graphics.drawCircle(25,7.5,2.5);
				 
				 //LinkerPfeil
				 SwiperBut.graphics.beginFill(SwiperColor,1);
				 SwiperBut.graphics.lineStyle(1,SwiperColor);
				 SwiperBut.graphics.moveTo(50,7.5);
				 SwiperBut.graphics.lineTo(40,0);
				 SwiperBut.graphics.lineTo(40,5);
				 SwiperBut.graphics.lineTo(30,5);
				 SwiperBut.graphics.lineTo(30,10);
				 SwiperBut.graphics.lineTo(40,10);
				 SwiperBut.graphics.lineTo(40,15);
				 SwiperBut.graphics.lineTo(50,7.5);
				 SwiperBut.graphics.endFill();
				
				
				 SwiperBut.scaleX = SwiperScale;
				 SwiperBut.scaleY = SwiperScale;
				 SwiperBut_mc.addChild(SwiperBut);
			
			}
			
			private function hideMouse(e:MouseEvent){
				Mouse.hide();
			}
			
			private function showMouse(e:MouseEvent){
				trace ("leaving focus");
				Mouse.show();
				SwiperBut_mc.x=0;
				SwiperBut_mc.y=0;
			}
		
			
		
	}// class close 
}// package close