﻿/*Scalebar 


Legt einen Maßstabsbalken Balken an der bei Null beginnt und dann entspechend der
Auflösung (1 Pixel entspricht wie viel Einheiten der gewählten einheit)) und der 
vorgegebenen Länge dimensioniert ist.*/


package com.utilities {
	
import flash.display.*;
import flash.geom.*;
import flash.utils.*;
import flash.text.*;
import flash.events.*;

	public class Scalebar extends Sprite{
		private var ScaleContainer:Sprite; 	// Container für Scalebebar
		private var Resolution:int;		   	// Auflösung
		private var X_Ext:int;				// Breite der Scalebar
		private var Y_Ext:int;				// Höhe der Scalebar
		private var Unit:String;			// Einheit der Scalebar
		private var ColorStyle:int;			// Farbe der Sclaebar und der Schrift
		private var MaxValue:int;			// Wert am Ende der Leiste
		public var Alpha:Number;				// Transparenz
		
		
		/*Constructor benötigt: R= Auflösung; W Breite in Pixeln; H: Höhe in Pixeln;
		Optional = U: Ein String mit der Einheit;CS: Farbgebung; Rnd = gerundet:Boolean); Alpha:int*/
		
		public function Scalebar(R:int,W:int,H:int,U:String = "m",CS:int = 0x000000,Rnd:Boolean = false,Al:Number = 1){ 
			Resolution = R;
			X_Ext = W;
			Y_Ext = H;
			Unit = U;
			ColorStyle = CS;
			Alpha = Al;
			MaxValue = X_Ext*Resolution
			ScaleContainer = new Sprite();
			addChild(ScaleContainer);
			
			/*Falls gerundert werden soll: */
			
			if (Rnd == true){
			roundValues();
			}
			
			createScalebar();
			
		}// Constructor close
		
		public function createScalebar(){
			
			var Frame = new Shape();
			Frame.graphics.lineStyle(1,ColorStyle);
			Frame.graphics.beginFill(ColorStyle);
			Frame.graphics.drawRect(0,0,X_Ext,Y_Ext);
			Frame.graphics.beginFill(0xFFFFFF);
			Frame.graphics.drawRect(0,0,X_Ext/2,Y_Ext/2);
			Frame.graphics.drawRect(X_Ext/2,Y_Ext/2,X_Ext/2,Y_Ext/2);
			Frame.alpha = Alpha;
			
			ScaleContainer.addChild(Frame);
			
			trace ("Breite Scalecontainer nach Scalebar  "+ ScaleContainer.width)
			var TextForm=new TextFormat();
			TextForm.size=9;
			TextForm.font = "Arial";
			TextForm.bold = true;
			TextForm.align = TextFormatAlign.LEFT;
			
			
			var zero_txt:TextField = new TextField();
			zero_txt.type = TextFieldType.INPUT;
			zero_txt.x=-20;
			zero_txt.autoSize = TextFieldAutoSize.LEFT;
			zero_txt.text = "0"+ Unit;
			zero_txt.textColor = ColorStyle;
			ScaleContainer.addChild(zero_txt);
			trace ("Breite Scalecontainer nach zero txt "+ ScaleContainer.width)
			zero_txt.setTextFormat(TextForm);
			
			var max_txt:TextField = new TextField();
			max_txt.type = TextFieldType.INPUT;
			max_txt.text = (MaxValue).toString() + Unit
			max_txt.autoSize = TextFieldAutoSize.LEFT,
			max_txt.x=X_Ext+1;
			max_txt.textColor = ColorStyle;
			max_txt.setTextFormat(TextForm);
			ScaleContainer.addChild(max_txt);
			trace ("Breite Scalecontainer nach maxtext"+ ScaleContainer.width)
		}
		
		/*Die Leiste soll immer runde Werte anzeigen wesswegen die Länge der Leiste
		angepasst wird*/
		
		private function roundValues(){
			var Length:int = X_Ext*Resolution;			 	// Zahl die eigentlich am Ender de Leiste stünde
			Length = (Math.round(Length/1000))*1000; 		// Zahl die eigentlich am Ender der Leiste stünde wird rundgemacht
			var Factor = X_Ext/(X_Ext*Resolution); 			// Eine Einheit auf der Leiste entspricht wie vielen Einheiten
			X_Ext = Factor*Length;
			MaxValue = Length;
			trace ("newlength "+Length);
		}
		
	}//Class close
}//Package close